;******************************* STERIA **************************************
; Fichier : $Id: pri-atelierb-mode.el,v 1.12 2000/11/08 15:35:31 clb Exp $
;
; (C) 2000 STERIA
;
; Description : Mode de preuve interactive
;               
; Auteur(s) :  clb
;
; Historique : $Log: pri-atelierb-mode.el,v $
; Historique : Revision 1.12  2000/11/08 15:35:31  clb
; Historique : Proved !!! => PO Proved
; Historique :
; Revision 1.11  2000/11/08  13:38:16  clb
; Message Proved!!! quand une PO est prouvee.
;
; Revision 1.10  2000/11/06  16:24:13  clb
; Ajout du menu dans le buffer pri-log.
;
; Historique : Revision 1.9  2000/11/06 11:29:19  clb
; Historique : Correction de l'expression des messages du kernel.
; Historique :
; Revision 1.8  2000/11/03  13:54:11  clb
; Nouveau Menu PRI : item Customize, Save, About Emacspri, Exit.
;
; Revision 1.7  2000/11/03  10:14:10  clb
; $0 n'est plus colorie.
;
; Revision 1.6  2000/11/02  15:11:52  clb
; Nouvelle table de syntaxe dans le mode atelierb pour la selection souris
; et la completion automatique des idents.
;
; Revision 1.5  2000/10/27  10:36:31  clb
; Le buffer *scratch* n'est plus en mode PRI.
; Correction des C-x C-c et File->Exit Emacs.
;
; Historique : Revision 1.4  2000/10/03 15:26:24  clb
; Historique : Ajout du but dans la fenetre Log.
; Historique : Ajout de cmd: et goal: en inverse video dans la fenetre log.
; Historique :
; Revision 1.3  2000/09/26  14:39:45  clb
; ajout d'un mode trace pour le debug.
; pri-trace ==> pri-terminal-print.
; enlevement du autoload de pri-trace aux endroits inutiles.
;
; Revision 1.2  2000/06/30  09:37:43  clb
; ajout des entetes de fichiers
;
;
;*****************************************************************************
;;(autoload 'pri-toolbar "pri-toolbar")
;;(autoload 'pri-save "pri-toolbar")
(autoload 'pri-exit "pri-terminal")
(autoload 'pri-prouveur-send-command "pri-terminal")
(autoload 'cansell-affiche-balbulette-bis "pri-tools")

;;*****************************************************************************
;; VARIABLES
(defvar pri-mode-map nil "Table d'associations des touches du mode pri.")
(defvar pri-mode-menu (make-sparse-keymap) "Interactive Proof Menu")

; creation d'une table de syntaxe pour mode B
; conditionne ce qui est selectionne quand on double clique,
; les deplacements avec M-f et M-b, etc, ainsi que la reconnaissance
; des commentaires par font-lock
(defvar B-mode-syntax-table nil
  "Syntax table in use in B-mode buffers. Should make word selection
and word move easy.")
(if B-mode-syntax-table
    ()
  (setq B-mode-syntax-table (make-syntax-table))

  ; symboles speciaux ou d'operateurs : categorie poubelle "."
  ; serait mieux si les agregats formaient des symboles :
  ;   ex : aaa/|\bbb devraient etre trois mots, et dble clic dans /|\ devrait
  ;        selectionner ce symbole. Actuellement : aaa et bbb sont les seuls mots.
  (modify-syntax-entry ?! "." B-mode-syntax-table)
  (modify-syntax-entry ?# "." B-mode-syntax-table)
  (modify-syntax-entry ?% "." B-mode-syntax-table)
  (modify-syntax-entry ?& "." B-mode-syntax-table)
  (modify-syntax-entry ?+ "." B-mode-syntax-table)
  (modify-syntax-entry ?, "." B-mode-syntax-table)
  (modify-syntax-entry ?- "." B-mode-syntax-table)
  (modify-syntax-entry ?. "." B-mode-syntax-table)
  (modify-syntax-entry ?: "." B-mode-syntax-table)
  (modify-syntax-entry ?\; "." B-mode-syntax-table)
  (modify-syntax-entry ?< "." B-mode-syntax-table)
  (modify-syntax-entry ?= "." B-mode-syntax-table)
  (modify-syntax-entry ?> "." B-mode-syntax-table)
  (modify-syntax-entry ?? "." B-mode-syntax-table)
  (modify-syntax-entry ?\\ "." B-mode-syntax-table)
  (modify-syntax-entry ?^ "." B-mode-syntax-table)
  (modify-syntax-entry ?| "." B-mode-syntax-table)
  (modify-syntax-entry ?` "." B-mode-syntax-table)

  ; les quoted strings sont delimitees par des doubles quotes
  (modify-syntax-entry ?\" "\"" B-mode-syntax-table)

  ; les caracteres ne devant pas couper un mot
  ; ex : dble clic sur toto_titi, var$3, zzz~ ou fff'ddd doit selectionner
  ;      ces elements en entier.
  ; ATTENTION : les categories "_" ou "'" n'ont pas ete employees : sur Emacs
  ;   elles n'ont pas la propriete ci dessus. Pourtant, le concept de "symbole"
  ;   dans la doc de ces categories semblerait convenir... A voir.
  (modify-syntax-entry ?$ "w" B-mode-syntax-table)
  (modify-syntax-entry ?\' "w" B-mode-syntax-table)
  (modify-syntax-entry ?_ "w" B-mode-syntax-table)
  (modify-syntax-entry ?~ "w" B-mode-syntax-table)

  ; commentaires. On ne supporte pas le // C++
  ; pris isolement : categorie "." pour / et *
  ; / est le 1 du commentaire ouvrant et le 2 du fermant (4)
  ; * est le 2 du commentaire ouvrant et le 1 du fermant (3)
  (modify-syntax-entry ?* ". 23" B-mode-syntax-table)
  (modify-syntax-entry ?/ ". 14" B-mode-syntax-table)

  ; les parentheses : (X)emacs signale la correspondance a chaque fermante,
  ;   et dble clic sur une parenthese selectionne le bloc delimite.
  ; () sont predefinis.
  (modify-syntax-entry ?\[ "(]" B-mode-syntax-table)
  (modify-syntax-entry ?\] ")]" B-mode-syntax-table)
  (modify-syntax-entry ?\{ "(}" B-mode-syntax-table)
  (modify-syntax-entry ?\} ")}" B-mode-syntax-table))

(defconst pri-atelierb-font-lock-keywords
  (purecopy
   (list
        '("SUCCESS" . pri-red-bold-face)
        '("^ GL .*" . pri-blue-bold-face)
       ;; '("---.*" . pri-blue-bold-face)
        '("^\\\[SL\\\].*" . pri-blue-bold-face)
        '("^\\\[RS\\\].*" . pri-blue-bold-face)
        '("^\\\[KH\\\].*" . pri-blue-bold-face)
	'("^ => *as$" . pri-red-bold-face)
	'("^ => *\\?" . pri-red-bold-face)
        '("^\\(MACHINE\\|SETS\\|CONSTANTS\\|PROPERTIES\\|ASSERTIONS\\|REFINEMENT\\|REFINES\\|VARIABLES\\|INVARIANT\\|INITIALISATION\\|OPERATIONS\\|END\\)". pri-red-bold-face) 
        '("\\(SELECT\\|IF\\|THEN\\|ANY\\|WHERE\\|ELSE\\|BEGIN\\|END\\)". pri-blue-bold-face) 
;;	'("^   goal:.*$" . pri-inverse-face)
;; '(".*&$" . pri-test-bold-face)
;; '(" .*" . pri-test-bold-face)


	;; resultats des commandes
;;	(list "^cmd:.*\n\\(.*\\)$" '(1 pri-inverse-face t))
;;	'("^cmd:" . pri-inverse-face)
;;	'("\\*\\*\\|\\+->>?\\|-\\(?:->>?\\|>\\)\\|\\.\\.\\|/\\(?:<\\(?::\\|<:\\)\\||\\\\\\|[:=\\]\\)\\|:[:=]\\|<\\(?:-[>-]\\|<[:|]\\|=>\\|[+:=|-]\\)\\|=>\\|>\\(?:\\+>>?\\|->>?\\|[<=]\\)\\|\\\\\\(?:/\\||/\\)\\||\\(?:->\\|>>\\|[>|]\\)\\|[!#%&'*+,./:->|~^-]" . font-lock-function-name-face)
;;	'("\\<\\(INTER\\|PI\\|SIGMA\\|UNION\\|bool\\|c\\(?:ard\\|losure1?\\|onc\\)\\|dom\\|f\\(?:irst\\|nc\\|ront\\)\\|i\\(?:d\\|nter\\|terate\\)\\|last\\|m\\(?:ax\\|in\\|od\\)\\|not\\|or\\|pr\\(?:ed\\|j[12]\\)\\|r\\(?:an\\|e[clv]\\)\\|s\\(?:ize\\|ucc\\)\\|tail\\|union\\)\\>" . font-lock-function-name-face)
;;	'("\\<\\(BOOL\\|F\\(?:ALSE\\|IN1?\\)\\|INT\\(?:EGER\\)?\\|M\\(?:AXINT\\|ININT\\)\\|NAT\\(?:1\\|URAL1?\\)?\\|POW1?\\|STRING\\|TRUE\\|\\[\\]\\|iseq1?\\|perm\\|s\\(?:eq1?\\|kip\\|truct\\)\\|{}\\)\\>" . font-lock-type-face)
       
	))
  "Highlight B")

(defconst pri-about-buffer-name "*About Click'n'Prove...*")

(defconst pri-about-string
	(concat "Click'n'Prove : version 1.3\n\n")

  "String About Emacspri..."
)

;;*****************************************************************************
;; FONCTIONS
(defun pri-about ()
"Affiche dans le tampon *About Emacspri...* les informations sur l'emacspri utilise."
  (interactive)
;  (split-window-vertically)
;  (pop-to-buffer pri-about-buffer-name)
  (message pri-about-string))



;;*****************************************************************************
;; MENU PRI
(defun pri-create-menu ()
  "Create the PRI menu as shown in the menu bar.
This function is designed to be extensible, so that each compiler-specific file
can add its own items"

  ;;  Note that the separators must have different length in the submenus
	(easy-menu-define
	 pri-mode-menu pri-mode-map "Menu keymap for PRI mode"
	 '("CnP"
	   ["About Click'n'Prove..." pri-about t]
	   ;["-" nil nil]
	   ;["Save" pri-save t]	   
	   ;["--" nil nil]
	   ;["Customize" (customize-group 'pri) (>= emacs-major-version 20)]
      ( "B logical operator"
 	 ["and           &" B-prover-insert-and (string= (buffer-name (current-buffer)) "pri-log")]
 	 ["or           or" B-prover-insert-or (string= (buffer-name (current-buffer)) "pri-log")]
 	 ["imply        =>" B-prover-insert-imply (string= (buffer-name (current-buffer)) "pri-log")]
 	 ["equiv.      <=>" B-prover-insert-equiv (string= (buffer-name (current-buffer)) "pri-log")]
 	 ["not       not()" B-prover-insert-not (string= (buffer-name (current-buffer)) "pri-log")]
 	 ["forall     !.()" B-prover-insert-forall (string= (buffer-name (current-buffer)) "pri-log")]
 	 ["exists     #.()" B-prover-insert-exists (string= (buffer-name (current-buffer)) "pri-log")])
     ( "B set"
	 ["empty set {}" B-prover-insert-empty-set (string= (buffer-name (current-buffer)) "pri-log")]
	 ["NATURAL"      B-prover-insert-natural (string= (buffer-name (current-buffer)) "pri-log")]
	 ["NATURAL1"     B-prover-insert-natural1 (string= (buffer-name (current-buffer)) "pri-log")]
	 ["INTEGER"      B-prover-insert-integer (string= (buffer-name (current-buffer)) "pri-log")]
	 ["BOOL"         B-prover-insert-bool (string= (buffer-name (current-buffer)) "pri-log")])
     ( "B set operator"
	 ["membership              :" B-prover-insert-membership (string= (buffer-name (current-buffer)) "pri-log")]
	 ["intersection           /\\" B-prover-insert-bin-inter (string= (buffer-name (current-buffer)) "pri-log")]
	 ["union                  \\/" B-prover-insert-bin-union (string= (buffer-name (current-buffer)) "pri-log")]
	 ["inclusion              <:" B-prover-insert-inclu (string= (buffer-name (current-buffer)) "pri-log")]
	 ["non inclusion         /<:" B-prover-insert-non-inclu (string= (buffer-name (current-buffer)) "pri-log")]
	 ["strict inclusion      <<:" B-prover-insert-strict-inclu (string= (buffer-name (current-buffer)) "pri-log")]
	 ["non strict inclusion /<<:" B-prover-insert-non-strict-inclu (string= (buffer-name (current-buffer)) "pri-log")]
	 ["POW()" B-prover-insert-pow (string= (buffer-name (current-buffer)) "pri-log")]
	 ["POW1()" B-prover-insert-pow1 (string= (buffer-name (current-buffer)) "pri-log")]
	 ["FIN()" B-prover-insert-fin (string= (buffer-name (current-buffer)) "pri-log")]
	 ["FIN1()" B-prover-insert-fin1 (string= (buffer-name (current-buffer)) "pri-log")]
	 ["inter()" B-prover-insert-inter (string= (buffer-name (current-buffer)) "pri-log")]
	 ["union()" B-prover-insert-union (string= (buffer-name (current-buffer)) "pri-log")]
	 ["INTER()( | )" B-prover-insert-INTER (string= (buffer-name (current-buffer)) "pri-log")]
	 ["UNION()( | )" B-prover-insert-UNION (string= (buffer-name (current-buffer)) "pri-log")] )
     ( "B set relation"
	 ["relation            <->" B-prover-insert-relation (string= (buffer-name (current-buffer)) "pri-log")]
	 ["partial function    +->" B-prover-insert-pfunc (string= (buffer-name (current-buffer)) "pri-log")]
	 ["total function      -->" B-prover-insert-func (string= (buffer-name (current-buffer)) "pri-log")]
	 ["partial injection   >+>" B-prover-insert-pinto (string= (buffer-name (current-buffer)) "pri-log")]
	 ["total injection     >->" B-prover-insert-into (string= (buffer-name (current-buffer)) "pri-log")]
	 ["partial surjection +->>" B-prover-insert-poutto (string= (buffer-name (current-buffer)) "pri-log")]
	 ["total surjection   -->>" B-prover-insert-outto  (string= (buffer-name (current-buffer)) "pri-log")]
	 ["bijection          >->>" B-prover-insert-bijection  (string= (buffer-name (current-buffer)) "pri-log")]
	 ["overwrite            <+" B-prover-insert-overwrite (string= (buffer-name (current-buffer)) "pri-log")]
	 ["restriction          <|" B-prover-insert-restriction (string= (buffer-name (current-buffer)) "pri-log")]
	 ["anti-restriction    <<|" B-prover-insert-anti-restriction  (string= (buffer-name (current-buffer)) "pri-log")]
	 ["co-restriction       |>" B-prover-insert-co-restriction (string= (buffer-name (current-buffer)) "pri-log")]
	 ["co-anti-restriction |>>" B-prover-insert-co-anti-restriction  (string= (buffer-name (current-buffer)) "pri-log")]
	 ["inverse               ~" B-prover-insert-inverse (string= (buffer-name (current-buffer)) "pri-log")])
	   ["---" nil nil]
	   ["Exit" pri-exit t]	   
	   ))
	
	(easy-menu-add pri-mode-menu)
	(define-key pri-mode-map [menu-bar] pri-mode-menu)
	
	)

(defun B-ensure-space-before ()
  "Ensure there is a space before point.
   If it is not the case, a space is inserted before point."
  (or (= (char-syntax (preceding-char)) ?\ )
      (insert " "))
)

(defun B-ensure-space-after ()
  "Ensure there is a space after point.
   If it is not the case, a space is inserted before point."
  (or (= (char-syntax (following-char)) ?\ )
      (insert " "))
)

(defun B-prover-insert-integer-like (keyword)
  "Insert a keyword similar to INTEGER at point."
  (B-ensure-word-boundary-before)
  (insert keyword)
  (x-symbol-decode)
)

(defun B-prover-insert-pow-like (keyword)
  "Insert a keyword similar to POW at point."
  (B-ensure-word-boundary-before)
  (insert keyword "()")
  (backward-char 1)
  (x-symbol-decode)
)

(defun B-prover-insert-UNION-like (keyword)
  "Insert a keyword similar to UNION at point."
  (interactive "*p")
  (B-ensure-word-boundary-before)
  (insert keyword "()( | )")
  (backward-char-command 6)
  (x-symbol-decode)
)

(defun B-prover-insert-between-spaces (string)
  "Insert STRING ensuring a space before and after."
  (B-ensure-space-before)
  (insert string)
  (B-ensure-space-after)
  (x-symbol-decode)
)

(defun B-prover-insert-forall-like (string)
  "add keyword !"
  (interactive "*p")
  (B-ensure-space-before)
  (insert string ".()")
  (backward-char 3)
  (x-symbol-decode)
)


;;; menu commands
(defun B-prover-insert-natural (&optional async)
  "add keyword NATURAL"
  (interactive "*p")
  (B-prover-insert-integer-like "NATURAL")
)

(defun B-prover-insert-natural1 (&optional async)
  "add keyword NATURAL1"
  (interactive "*p")
  (B-prover-insert-integer-like "NATURAL1")
)

(defun B-prover-insert-integer (&optional async)
  "add keyword INTEGER"
  (interactive "*p")
  (B-prover-insert-integer-like "INTEGER")
)

(defun B-prover-insert-bool (&optional async)
  "add keyword BOOL"
  (interactive "*p")
  (B-prover-insert-integer-like "BOOL")
)

(defun B-prover-insert-empty-set (&optional async)
  "add keyword {}"
  (interactive "*p")
  (insert "{}")
  (x-symbol-decode)
)

(defun B-prover-insert-pow (&optional async)
  "add keyword POW"
  (interactive "*p")
  (B-prover-insert-pow-like "POW")
)

(defun B-prover-insert-pow1 (&optional async)
  "add keyword POW1"
  (interactive "*p")
  (B-prover-insert-pow-like "POW1")
)

(defun B-prover-insert-fin (&optional async)
  "add keyword FIN"
  (interactive "*p")
  (B-prover-insert-pow-like "FIN")
)

(defun B-prover-insert-fin1 (&optional async)
  "add keyword FIN1"
  (interactive "*p")
  (B-prover-insert-pow-like "FIN1")
)

(defun B-prover-insert-union (&optional async)
  "add keyword union"
  (interactive "*p")
  (B-prover-insert-pow-like "union")
)

(defun B-prover-insert-inter (&optional async)
  "add keyword inter"
  (interactive "*p")
  (B-prover-insert-pow-like "inter")
)

(defun B-prover-insert-UNION (&optional async)
  "add keyword union"
  (interactive "*p")
  (B-prover-insert-UNION-like "UNION")
)

(defun B-prover-insert-INTER (&optional async)
  "add keyword inter"
  (interactive "*p")
  (B-prover-insert-UNION-like "INTER")
)

(defun B-prover-insert-and (&optional async)
  "add keyword &"
  (interactive "*p")
  (B-prover-insert-between-spaces "&")
)

(defun B-prover-insert-or (&optional async)
  "add keyword or"
  (interactive "*p")
  (B-prover-insert-between-spaces "or")
) 

(defun B-prover-insert-imply (&optional async)
  "add keyword =>"
  (interactive "*p")
  (B-prover-insert-between-spaces "=>")
)

(defun B-prover-insert-equiv (&optional async)
  "add keyword <=>"
  (interactive "*p")
  (B-prover-insert-between-spaces "<=>")
)

(defun B-prover-insert-not (&optional async)
  "add keyword not"
  (interactive "*p")
  (B-prover-insert-pow-like "not")
)

(defun B-prover-insert-forall (&optional async)
  "add keyword !"
  (interactive "*p")
  (B-prover-insert-forall-like "!")
)

(defun B-prover-insert-exists  (&optional async)
  "add keyword #"
  (interactive "*p")
  (B-prover-insert-forall-like "#")
)

(defun B-prover-insert-inverse (&optional async)
  "add keyword ~"
  (interactive "*p")
  (insert "~" )
  (x-symbol-decode)
)

(defun B-prover-insert-membership(&optional async)
  "add keyword :"
  (interactive "*p")
  (B-insert-between-spaces ":")
)	
(defun B-prover-insert-bin-inter (&optional async)
  "add keyword /\\"
  (interactive "*p")
  (B-prover-insert-between-spaces "/\\")
)	

(defun B-prover-insert-bin-union (&optional async)
  "add keyword \//"
  (interactive "*p")
  (B-prover-insert-between-spaces "\//")
)

(defun B-prover-insert-inclu (&optional async)
  "add keyword <:"
  (interactive "*p")
  (B-prover-insert-between-spaces "<:")
)

(defun B-prover-insert-non-inclu (&optional async)
  "add keyword /<:"
  (interactive "*p")
  (B-prover-insert-between-spaces "/<:" )
)

(defun B-prover-insert-strict-inclu (&optional async)
  "add keyword <<:"
  (interactive "*p")
  (B-prover-insert-between-spaces "<<:"  )
)

(defun B-prover-insert-non-strict-inclu (&optional async)
  "add keyword  /<<:"
  (interactive "*p")
  (B-prover-insert-between-spaces "/<<:" )
)

(defun B-prover-insert-relation (&optional async)
  "add keyword <->"
  (interactive "*p")
  (B-prover-insert-between-spaces "<->")
)

(defun B-prover-insert-pfunc (&optional async)
  "add keyword +->"
  (interactive "*p")
  (B-prover-insert-between-spaces "+->")
)

(defun B-prover-insert-func (&optional async)
  "add keyword -->"
  (interactive "*p")
  (B-prover-insert-between-spaces "-->")
)
(defun B-prover-insert-pinto (&optional async)
  "add keyword >+>"
  (interactive "*p")
  (B-prover-insert-between-spaces ">+>")
)

(defun B-prover-insert-into (&optional async)
  "add keyword >->"
  (interactive "*p")
  (B-prover-insert-between-spaces ">->")
)
(defun B-prover-insert-poutto (&optional async)
  "add keyword +->>"
  (interactive "*p")
  (B-prover-insert-between-spaces "+->>")
)

(defun B-prover-insert-outto (&optional async)
  "add keyword -->>"
  (interactive "*p")
  (B-prover-insert-between-spaces "-->>")
)

(defun B-prover-insert-bijection (&optional async)
  "add keyword >->>"
  (interactive "*p")
  (B-prover-insert-between-spaces ">->>")
)

(defun B-prover-insert-overwrite (&optional async)
  "add keyword <+"
  (interactive "*p")
  (B-prover-insert-between-spaces "<+")
)

(defun B-prover-insert-restriction (&optional async)
  "add keyword <|"
  (interactive "*p")
  (B-prover-insert-between-spaces "<|")
)

(defun B-prover-insert-anti-restriction (&optional async)
  "add keyword <<|"
  (interactive "*p")
  (B-prover-insert-between-spaces "<<|")
)

(defun B-prover-insert-co-restriction (&optional async)
  "add keyword |>"
  (interactive "*p")
  (B-prover-insert-between-spaces "|>")
)

(defun B-prover-insert-co-anti-restriction (&optional async)
  "add keyword |>>"
  (interactive "*p")
  (B-prover-insert-between-spaces "|>>")
)

;;*****************************************************************************
;;modifie le menu File->Exit XEmacs
(eval-and-compile
(defun pri-change-exit-emacs-menu ()
  "modifie le menu File->Exit XEmacs... pourqu'il appelle la fonction pri-exit"
  (add-menu-button '("File") ["Exit XEmacs" pri-exit t])))




(eval-and-compile
(defun cansell-SH ()
(interactive)
(if  cansell-affiche-help
  ()
  (progn (x-symbol-encode)(if (region-active-p) 

       (pri-prouveur-send-command (concat "sh(" (buffer-string (mark) (point)) ")"))
     (let ((lavaleur (widget-value le-champ-editable)))
     (if (string= lavaleur "") ()
           (pri-prouveur-send-command (concat "sh(" (widget-value le-champ-editable) ")"))
))) (x-symbol-decode)))))

(eval-and-compile
(defun cansell-paste ()

  (interactive)

(if (region-active-p) 
(progn
(setq cansell-string-to-paste (buffer-string (mark) (point)))
 (goto-char (widget-field-start le-champ-editable))
(forward-char-command (length (widget-value le-champ-editable)))
(insert (replace-in-string cansell-string-to-paste "\n" ""))(setq LaFinEd (point))      
(widget-setup)
)))
)
;;*****************************************************************************
;; MODE PRI




(eval-and-compile
(defun pri-atelierb-mode ()
  "Mode de preuve interactive"
  (interactive)
  (kill-all-local-variables)
  (make-face 'pri-red-bold-face)
  (make-face 'pri-test-bold-face)
  (make-face 'pri-red-face)
 (make-face 'pri-blue-face) 
 (make-face 'pri-blue-bold-face)
  (make-face 'pri-button-red-face)
  (make-face 'pri-button-blue-face)
  (custom-set-faces
   '(pri-red-bold-face ((((class color))  (:foreground "red"))))
   '(pri-red-face ((((class color))  (:foreground "red"))))
   '(pri-blue-face ((((class color))  (:foreground "blue")))) 
   '(pri-blue-bold-face ((((class color))  (:foreground "blue")))) 
   '(pri-test-bold-face ((((class color))  (:foreground "black"))));; '(pri-button-red-face ((t  (:bold t) (:foreground "red"))))
)
  (make-face-bold 'pri-red-bold-face)
  (make-face-bold 'pri-blue-bold-face)
  (make-face-bold 'pri-test-bold-face)
 (copy-face 'widget-button-face 'pri-button-red-face)
(set-face-foreground 'pri-button-red-face"red")
 (copy-face 'widget-button-face 'pri-button-blue-face)
(set-face-foreground 'pri-button-blue-face"blue")

;;   '(pri-inverse-face ((((class color)) (:foreground "white" :background "black")))))
  (setq major-mode 'pri-atelierb-mode)
  (setq mode-name "PRI")

  (run-hooks 'pri-atelierb-mode-hook)
  (turn-on-font-lock)

  (set-syntax-table B-mode-syntax-table)

  (if pri-mode-map
	  nil
	(setq pri-mode-map (make-sparse-keymap))
	;; avant de quitter emacs on quit le prouveur interactif
	(define-key pri-mode-map "\C-x\C-c" 'pri-exit)
	(define-key pri-mode-map "\C-l" 'cansell-affiche-balbulette-bis)
	(define-key pri-mode-map "\C-m" 'cansell-affiche-balbulette-bis)
	(define-key pri-mode-map [button2] 'cansell-paste)
	(define-key pri-mode-map [button3] 'cansell-SH)
	)
  (use-local-map pri-mode-map)
  
  (pri-change-exit-emacs-menu)
  (pri-create-menu)

 ;; (pri-toolbar)
 (setq truncate-lines t) 
  (setq buffer-read-only nil)
  (setq inhibit-read-only t) 
 ))

;;*****************************************************************************
