;******************************* STERIA **************************************
; Fichier : $Id: pri-goal.el,v 1.11 2000/11/06 16:24:16 clb Exp $
;
; (C) 2000 STERIA
;
; Description : Fenetre du but
;               
; Auteur(s) :  clb
;
; Historique : $Log: pri-goal.el,v $
; Historique : Revision 1.11  2000/11/06 16:24:16  clb
; Historique : Ajout du menu dans le buffer pri-log.
; Historique :
; Revision 1.10  2000/10/27  10:36:32  clb
; Le buffer *scratch* n'est plus en mode PRI.
; Correction des C-x C-c et File->Exit Emacs.
;
; Historique : Revision 1.9  2000/10/26 09:47:05  clb
; Historique : Les buffers : goal, hyp, proof-tree et old-proof sont maintenant read-only.
; Historique :
; Historique : Revision 1.8  2000/10/24 08:09:28  clb
; Historique : Modification des messages pour la version 3.6 de l'AtelierB.
; Historique :
; Historique : Revision 1.7  2000/10/12 13:51:54  clb
; Historique : Suppression de la fenetre global situation :
; Historique : les infos se retrouvent dans la ligne de mode (modeline).
; Historique :
; Revision 1.6  2000/10/02  13:23:28  clb
; Suppression de la fenetre terminal.
; C'est le minibuffer qui sert de terminal.
; Revue des autoloads suite a la compilation de tous les fichiers.
; La seule fenetre au debut est la fenetre Log.
; Correction de pri-version qui etait defini deux fois differements.
; Ajout du fichier pri-traces.el
;
; Revision 1.5  2000/09/27  16:19:58  clb
; Ajout de la toolbar PRI : elle ne contient pour l'instant que le bouton Exit.
; pri-quit => pri-exit.
;
; Revision 1.4  2000/09/26  14:39:46  clb
; ajout d'un mode trace pour le debug.
; pri-trace ==> pri-terminal-print.
; enlevement du autoload de pri-trace aux endroits inutiles.
;
; Revision 1.3  2000/09/25  12:35:49  clb
; synchronisation d'Emacs et du prouvuer interactif :
; attente du prompt PRI> avant de lancer une nouvelle commande.
; enlevement des traces du debut d'Emacs dans la fenetre terminal :
; on arrive sur : PRI>.
;
; Revision 1.2  2000/06/30  09:37:44  clb
; ajout des entetes de fichiers
;
;
;*****************************************************************************
(autoload 'pri-process-hyp-command "pri-hypotheses-list")
(autoload 'pri-goal "pri-main")
  
;;*****************************************************************************
(eval-and-compile
(defun pri-goal-mode ()
  "Mode pour le but"
  (pop-to-buffer PRI-GOAL)
  (pri-atelierb-mode)
  (setq mode-popup-menu  
		`("Actions on Goal" 
		  ["pr - Proof" (pri-send-command "pr") t]
		  [ "mp - Mini Proof"  (pri-send-command "mp") t] 
		  [ "pp(rp.0) - Reduced Predicate Prover" (pri-send-command "pp(rp.0)") t]
		  [ "ap - Arithmetical Prover" (pri-send-command "ap") t]
		  [ "ss - Set Solver" (pri-send-command "ss") t]
		  [ "dd - Deduction" (pri-send-command "dd") t]
		  [ "dd(0) - Deduction force 0" (pri-send-command "dd(0)") t]
		  [ "ct - Proof by Contradiction" (pri-send-command "ct") t]
		  [ "cts - Special Contradiction" (pri-send-command "cts") t]
		  [ "tp(Hyp) - Proof by attempts" (pri-send-command "tp(Hyp)") t]
		  [ "tp(Goal) - Proof by attempts" (pri-send-command "tp(Goal)") t]
		  [ "ch - Create Hypothesis" (pri-send-command "ch") t]
		  [ "sh - Search Hypothesis" (pri-process-hyp-command "sh") t]
		  ))
  ))
;;*****************************************************************************
