;******************************* STERIA **************************************
; Fichier : $Id: pri-log.el,v 1.19 2000/11/08 15:50:51 clb Exp $
;
; (C) 2000 STERIA
;
; Description : Fenetre d'affichage des messages du prouveur
;               
; Auteur(s) :  clb
;
; Historique : $Log: pri-log.el,v $
; Historique : Revision 1.19  2000/11/08 15:50:51  clb
; Historique : Modifications du menu pop-up de pri-log.
; Historique :
; Revision 1.18  2000/11/08  10:56:05  clb
; Ajout du menu eh(goal) dans pri-log.
;
; Revision 1.17  2000/11/07  11:15:25  clb
; Positionnement du curseur dans la fenetre pri-log :
; moins de ligne blanche en dessous de l'info utile.
;
; Revision 1.16  2000/11/06  16:24:17  clb
; Ajout du menu dans le buffer pri-log.
;
; Revision 1.15  2000/10/27  10:36:33  clb
; Le buffer *scratch* n'est plus en mode PRI.
; Correction des C-x C-c et File->Exit Emacs.
;
; Revision 1.14  2000/10/26  12:58:49  clb
; Le Try Everywhere ne saut plus une ligne a chaque +/-.
; On ne vide plus le buffer log au changement de PO :
; ca vidait le buffer en fin de tryeverywhere,
; du coup on n'avait pas les resultats .
;
; Historique : Revision 1.13  2000/10/26 09:08:23  clb
; Historique : Vidage du buffer pri-log au changement de PO.
; Historique : Rattrappage des erreurs en cas de lock sur le composant choisi.
; Historique :
; Historique : Revision 1.12  2000/10/24 09:16:47  clb
; Historique : nouvelles icones pp et pp0. correction d'"autoload".
; Historique : La version V1.1.18 ne marche pas.
; Historique :
; Historique : Revision 1.11  2000/10/24 08:09:29  clb
; Historique : Modification des messages pour la version 3.6 de l'AtelierB.
; Historique :
; Historique : Revision 1.10  2000/10/18 14:36:02  clb
; Historique : ouverture d'un composant sur la liste des POs.
; Historique : clic sur une PO => ouverture du tampon Log.
; Historique :
; Historique : Revision 1.9  2000/10/18 07:56:03  clb
; Historique : remise du en place du pri-output-filter de jfm :
; Historique : fin du tronquage de certains messages
; Historique :
; Historique : Revision 1.8  2000/10/12 13:51:55  clb
; Historique : Suppression de la fenetre global situation :
; Historique : les infos se retrouvent dans la ligne de mode (modeline).
; Historique :
; Revision 1.7  2000/10/03  12:46:07  clb
; Ajout des tampons de liste des projets et des composants.
; Ils permettent a l'utilisateur de choisir plus facilement
; le projet et le composant voulu.
;
; Revision 1.6  2000/10/02  15:40:33  clb
; Amelioration de la fenetre Log :
; 	suppression du prompt
; 	ajout des couleurs et de la toolbar
;
; Revision 1.5  2000/10/02  13:23:29  clb
; Suppression de la fenetre terminal.
; C'est le minibuffer qui sert de terminal.
; Revue des autoloads suite a la compilation de tous les fichiers.
; La seule fenetre au debut est la fenetre Log.
; Correction de pri-version qui etait defini deux fois differements.
; Ajout du fichier pri-traces.el
;
; Revision 1.4  2000/09/28  14:48:57  clb
; pri-terminal-print => pri-log-print (pri-terminal.el => pri-log.el)
;
; Revision 1.3  2000/09/27  16:19:59  clb
; Ajout de la toolbar PRI : elle ne contient pour l'instant que le bouton Exit.
; pri-quit => pri-exit.
;
; Revision 1.2  2000/06/30  09:37:44  clb
; ajout des entetes de fichiers
;
;
;*****************************************************************************
(autoload 'pri-trace "pri-traces")
(autoload 'PRI-LOG "pri-main")
(autoload 'pri-before-writting-buffer "pri-main")
(autoload 'pri-after-writting-buffer "pri-main")
(autoload 'pri-tools "pri-end-of-buffer")
(autoload 'pri-tools "pri-machines-mode")

;;*****************************************************************************
;; impression dans la fenetre log
(defvar pri-log-print-p t "indique la presence de traces dans la fenetre terminal")

(eval-and-compile
(defun pri-log-print (string)
  (pri-trace (format "pri-log-print: %s\n" string))
 	   	(pri-before-writting-buffer PRI-LOG)
		(goto-char (point-max))
		(insert-string
		 
		 ;; pour le  TryEverywhere : quand on a les +/- :
		 ;;on ne saute pas une ligne a chaque fois
		 (cond
		  ((or (string= string "+")
			   (string= string "-"))
		   string)

		  ((string= string "Summary")
		   (concat  "   " string ))

		  (t (concat  "   " string  ))
		  ))

		;;(pri-end-of-buffer)
	   	(pri-after-writting-buffer)))

;;*****************************************************************************
;; lancement d'une commande a partir d'une region selectionnee
(eval-and-compile
(defun pri-command-on-region (command)
  (if (region-active-p)
	  (pri-send-command 
	   (concat command "(" (buffer-string (mark) (point)) ")"))
	(message (concat "you must select an expression for command " command)))))

;;*****************************************************************************
;;lance le mode PRI
(eval-and-compile
(defun pri-log-mode ()
  "Trace d'excution du prouveur interactif"
(setq truncate-lines t)
 (pop-to-buffer  PRI-LOG nil cansell-proj-frame) 
 (pri-atelierb-mode)


  ))

(provide 'pri-log-mode)

