(defvar pri-machines-mode-hook nil)

;(add-to-list 'auto-mode-alist '("\\.mch\\'" . pri-machines-mode))


;; Utilities


(defvar pri-machines-mode-map nil "Table d'associations des touches du mode pri.")
(defvar pri-machines-mode-menu (make-sparse-keymap) "Interactive Proof Menu")

(defconst pri-machines-font-lock-keywords
  (purecopy
   (list
        '("^\\(MODEL\\|MACHINE\\|SETS\\|SEES\\|DEFINITIONS\\|INCLUDES\\|EXTENDS\\|CONSTANTS\\|PROPERTIES\\|ASSERTIONS\\|THEOREMS\\|REFINEMENT\\|REFINES\\|VARIABLES\\|INVARIANT\\|INITIALISATION\\|OPERATIONS\\|EVENTS\\|END\\)". pri-machines-red-bold-face) 
        '("\\(SELECT\\|IF\\|PRE\\|WHEN\\|THEN\\|ANY\\|WHERE\\|ELSE\\|BEGIN\\|END\\)". pri-machines-blue-bold-face) 
;;	'("^   goal:.*$" . pri-machines-inverse-face)
;; '(".*&$" . pri-machines-test-bold-face)
;; '(" .+" . pri-machines-test-bold-face)


	;; resultats des commandes
;;	(list "^cmd:.*\n\\(.*\\)$" '(1 pri-machines-inverse-face t))
;;	'("^cmd:" . pri-machines-inverse-face)
;;	'("\\*\\*\\|\\+->>?\\|-\\(?:->>?\\|>\\)\\|\\.\\.\\|/\\(?:<\\(?::\\|<:\\)\\||\\\\\\|[:=\\]\\)\\|:[:=]\\|<\\(?:-[>-]\\|<[:|]\\|=>\\|[+:=|-]\\)\\|=>\\|>\\(?:\\+>>?\\|->>?\\|[<=]\\)\\|\\\\\\(?:/\\||/\\)\\||\\(?:->\\|>>\\|[>|]\\)\\|[!#%&'*+,./:->|~^-]" . font-lock-function-name-face)
;;	'("\\<\\(INTER\\|PI\\|SIGMA\\|UNION\\|bool\\|c\\(?:ard\\|losure1?\\|onc\\)\\|dom\\|f\\(?:irst\\|nc\\|ront\\)\\|i\\(?:d\\|nter\\|terate\\)\\|last\\|m\\(?:ax\\|in\\|od\\)\\|not\\|or\\|pr\\(?:ed\\|j[12]\\)\\|r\\(?:an\\|e[clv]\\)\\|s\\(?:ize\\|ucc\\)\\|tail\\|union\\)\\>" . font-lock-function-name-face)
;;	'("\\<\\(BOOL\\|F\\(?:ALSE\\|IN1?\\)\\|INT\\(?:EGER\\)?\\|M\\(?:AXINT\\|ININT\\)\\|NAT\\(?:1\\|URAL1?\\)?\\|POW1?\\|STRING\\|TRUE\\|\\[\\]\\|iseq1?\\|perm\\|s\\(?:eq1?\\|kip\\|truct\\)\\|{}\\)\\>" . font-lock-type-face)
       
	))
  "Highlight B")

(defvar B-mode-syntax-table nil
  "Syntax table in use in B-mode buffers. Should make word selection
and word move easy.")
(if B-mode-syntax-table
    ()
  (setq B-mode-syntax-table (make-syntax-table))

  ; symboles speciaux ou d'operateurs : categorie poubelle "."
  ; serait mieux si les agregats formaient des symboles :
  ;   ex : aaa/|\bbb devraient etre trois mots, et dble clic dans /|\ devrait
  ;        selectionner ce symbole. Actuellement : aaa et bbb sont les seuls mots.
  (modify-syntax-entry ?! "." B-mode-syntax-table)
  (modify-syntax-entry ?# "." B-mode-syntax-table)
  (modify-syntax-entry ?% "." B-mode-syntax-table)
  (modify-syntax-entry ?& "." B-mode-syntax-table)
  (modify-syntax-entry ?+ "." B-mode-syntax-table)
  (modify-syntax-entry ?, "." B-mode-syntax-table)
  (modify-syntax-entry ?- "." B-mode-syntax-table)
  (modify-syntax-entry ?. "." B-mode-syntax-table)
  (modify-syntax-entry ?: "." B-mode-syntax-table)
  (modify-syntax-entry ?\; "." B-mode-syntax-table)
  (modify-syntax-entry ?< "." B-mode-syntax-table)
  (modify-syntax-entry ?= "." B-mode-syntax-table)
  (modify-syntax-entry ?> "." B-mode-syntax-table)
  (modify-syntax-entry ?? "." B-mode-syntax-table)
  (modify-syntax-entry ?\\ "." B-mode-syntax-table)
  (modify-syntax-entry ?^ "." B-mode-syntax-table)
  (modify-syntax-entry ?| "." B-mode-syntax-table)
  (modify-syntax-entry ?` "." B-mode-syntax-table)

  ; les quoted strings sont delimitees par des doubles quotes
  (modify-syntax-entry ?\" "\"" B-mode-syntax-table)

  ; les caracteres ne devant pas couper un mot
  ; ex : dble clic sur toto_titi, var$3, zzz~ ou fff'ddd doit selectionner
  ;      ces elements en entier.
  ; ATTENTION : les categories "_" ou "'" n'ont pas ete employees : sur Emacs
  ;   elles n'ont pas la propriete ci dessus. Pourtant, le concept de "symbole"
  ;   dans la doc de ces categories semblerait convenir... A voir.
  (modify-syntax-entry ?$ "w" B-mode-syntax-table)
  (modify-syntax-entry ?\' "w" B-mode-syntax-table)
  (modify-syntax-entry ?_ "w" B-mode-syntax-table)
  (modify-syntax-entry ?~ "w" B-mode-syntax-table)

  ; commentaires. On ne supporte pas le // C++
  ; pris isolement : categorie "." pour / et *
  ; / est le 1 du commentaire ouvrant et le 2 du fermant (4)
  ; * est le 2 du commentaire ouvrant et le 1 du fermant (3)
  (modify-syntax-entry ?* ". 23" B-mode-syntax-table)
  (modify-syntax-entry ?/ ". 14" B-mode-syntax-table)

  ; les parentheses : (X)emacs signale la correspondance a chaque fermante,
  ;   et dble clic sur une parenthese selectionne le bloc delimite.
  ; () sont predefinis.
  (modify-syntax-entry ?\[ "(]" B-mode-syntax-table)
  (modify-syntax-entry ?\] ")]" B-mode-syntax-table)
  (modify-syntax-entry ?\{ "(}" B-mode-syntax-table)
  (modify-syntax-entry ?\} ")}" B-mode-syntax-table))
(eval-and-compile
(defun cansell-save-buffer ()
(interactive)
(save-buffer)
;;(setq cansell-affiche-dans-errors t)
(setq cansell-envoi-sml t)
(pri-atb-send-command "")))


;;*****************************************************************************
;;modifie le menu File->Exit XEmacs
(eval-and-compile
(defun pri-change-save-emacs-menu ()
  "modifie le menu File->Exit XEmacs... pourqu'il appelle la fonction pri-exit"
 (add-menu-button '("File") ["Save" cansell-save-buffer t])))

(defcustom cansell-toolbar-save-function 'cansell-save-buffer
  "*Function to call when the save icon is selected."
  :type '(radio (function-item cansell-save-buffer)
                (function :tag "Other"))
  :group 'toolbar)

(defun toolbar-save ()
  (interactive)
  (call-interactively cansell-toolbar-save-function))

(defun pri-machines-create-menu ()
  (easy-menu-define
    pri-machines-mode-menu  pri-machines-mode-map "B Mode menu"
    '( "B world"
       ["Refresh"  B-refresh t]
       "-"
       ( "B keywords"
	 ;; ["x-symbol" x-symbol-mode t]
	 ;; "-"
	 ["Insert REFINES" B-insert-refines t]
	 ["Insert SETS" B-insert-sets t]
	 ["Insert CONSTANTS" B-insert-constants t]
	 ["Insert PROPERTIES" B-insert-properties t]
	 ["Insert VARIABLES" B-insert-variables t]
	 ["Insert INVARIANT" B-insert-invariant t]
	 ["Insert DEFINITIONS" B-insert-definitions t]
	 ["Insert THEOREMS  (ASSERTIONS)" B-insert-assertions t]
	 ["Insert INITIALISATION" B-insert-initialisation t]
	 ["Insert EVENTS" B-insert-events t]
	 ["Insert comment" B-insert-comment t])
       ( "B substitution"
	 ["Insert BEGIN END" B-insert-begin-end t]
	 ["Insert SELECT" B-insert-select t]
	 ["Insert ANY" B-insert-any t]
	 ["Insert x:|( )" B-insert-such t]
	 ["Insert BEGIN END line" B-insert-begin-end-ln t]
	 ["Insert SELECT line" B-insert-select-ln t]
	 ["Insert ANY line" B-insert-any-ln t]) 
       ( "B logical operator"
 	 ["and           &" B-insert-and t]
 	 ["or           or" B-insert-or t]
 	 ["imply        =>" B-insert-imply t]
 	 ["equiv.      <=>" B-insert-equiv t]
 	 ["not       not()" B-insert-not t]
 	 ["forall     !.()" B-insert-forall t]
 	 ["exists     #.()" B-insert-exists t])
       ( "B set"
	 ["empty set {}" B-insert-empty-set t]
	 ["NATURAL"      B-insert-natural t]
	 ["NATURAL1"     B-insert-natural1 t]
	 ["INTEGER"      B-insert-integer t]
	 ["BOOL"         B-insert-bool t])
       ( "B set operator"
         ["membership              :" B-insert-membership t]
	 ["intersection           /\\" B-insert-bin-inter t]
	 ["union                  \\/" B-insert-bin-union t]
	 ["inclusion              <:" B-insert-inclu t]
	 ["non inclusion         /<:" B-insert-non-inclu t]
	 ["strict inclusion      <<:" B-insert-strict-inclu t]
	 ["non strict inclusion /<<:" B-insert-non-strict-inclu t]
	 ["POW()" B-insert-pow t]
	 ["POW1()" B-insert-pow1 t]
	 ["FIN()" B-insert-fin t]
	 ["FIN1()" B-insert-fin1 t]
	 ["inter()" B-insert-inter t]
	 ["union()" B-insert-union t]
	 ["INTER()( | )" B-insert-INTER t]
	 ["UNION()( | )" B-insert-UNION t] )
       ( "B set relation"
	 ["relation            <->" B-insert-relation t]
	 ["partial function    +->" B-insert-pfunc t]
	 ["total function      -->" B-insert-func t]
	 ["partial injection   >+>" B-insert-pinto t]
	 ["total injection     >->" B-insert-into t]
	 ["partial surjection +->>" B-insert-poutto t]
	 ["total surjection   -->>" B-insert-outto  t]
	 ["bijection          >->>" B-insert-bijection  t]
	 ["overwrite            <+" B-insert-overwrite t]
	 ["restriction          <|" B-insert-restriction t]
	 ["anti-restriction    <<|" B-insert-anti-restriction  t]
	 ["co-restriction       |>" B-insert-co-restriction t]
	 ["co-anti-restriction |>>" B-insert-co-anti-restriction  t]
	 ["inverse               ~" B-insert-inverse t])
       ))
     (easy-menu-add pri-machines-mode-menu)
     (define-key pri-machines-mode-map [menu-bar] pri-machines-mode-menu)
     )


;;; help for menu commands

(defun B-ensure-word-boundary-before ()
  "Ensure there is a word boundary before point.
   If it is not the case, a space is inserted before point."
  (and (= (char-syntax (preceding-char)) ?w)
       (insert " "))
)

(defun B-ensure-word-boundary-after ()
  "Ensure there is a word boundary after point.
   If it is not the case, a space is inserted before point."
  (and (= (char-syntax (following-char)) ?w)
       (insert " "))
)

(defun B-ensure-space-before ()
  "Ensure there is a space before point.
   If it is not the case, a space is inserted before point."
  (or (= (char-syntax (preceding-char)) ?\ )
      (insert " "))
)

(defun B-ensure-space-after ()
  "Ensure there is a space after point.
   If it is not the case, a space is inserted before point."
  (or (= (char-syntax (following-char)) ?\ )
      (insert " "))
)

(defun B-insert-integer-like (keyword)
  "Insert a keyword similar to INTEGER at point."
  (B-ensure-word-boundary-before)
  (insert keyword)
  (x-symbol-decode)
)

(defun B-insert-pow-like (keyword)
  "Insert a keyword similar to POW at point."
  (B-ensure-word-boundary-before)
  (insert keyword "()")
  (backward-char 1)
  (x-symbol-decode)
)

(defun B-insert-UNION-like (keyword)
  "Insert a keyword similar to UNION at point."
  (interactive "*p")
  (B-ensure-word-boundary-before)
  (insert keyword "()( | )")
  (backward-char-command 6)
  (x-symbol-decode)
)

(defun B-insert-between-spaces (string)
  "Insert STRING ensuring a space before and after."
  (B-ensure-space-before)
  (insert string)
  (B-ensure-space-after)
  (x-symbol-decode)
)

(defun B-insert-forall-like (string)
  "add keyword !"
  (interactive "*p")
  (B-ensure-space-before)
  (insert string ".()")
  (backward-char 3)
  (x-symbol-decode)
)


;;; menu commands
(defun B-insert-natural (&optional async)
  "add keyword NATURAL"
  (interactive "*p")
  (B-insert-integer-like "NATURAL")
)

(defun B-insert-natural1 (&optional async)
  "add keyword NATURAL1"
  (interactive "*p")
  (B-insert-integer-like "NATURAL1")
)

(defun B-insert-integer (&optional async)
  "add keyword INTEGER"
  (interactive "*p")
  (B-insert-integer-like "INTEGER")
)

(defun B-insert-bool (&optional async)
  "add keyword BOOL"
  (interactive "*p")
  (B-insert-integer-like "BOOL")
)

(defun B-insert-empty-set (&optional async)
  "add keyword {}"
  (interactive "*p")
  (insert "{}")
  (x-symbol-decode)
)

(defun B-insert-pow (&optional async)
  "add keyword POW"
  (interactive "*p")
  (B-insert-pow-like "POW")
)

(defun B-insert-pow1 (&optional async)
  "add keyword POW1"
  (interactive "*p")
  (B-insert-pow-like "POW1")
)

(defun B-insert-fin (&optional async)
  "add keyword FIN"
  (interactive "*p")
  (B-insert-pow-like "FIN")
)

(defun B-insert-fin1 (&optional async)
  "add keyword FIN1"
  (interactive "*p")
  (B-insert-pow-like "FIN1")
)

(defun B-insert-union (&optional async)
  "add keyword union"
  (interactive "*p")
  (B-insert-pow-like "union")
)

(defun B-insert-inter (&optional async)
  "add keyword inter"
  (interactive "*p")
  (B-insert-pow-like "inter")
)

(defun B-insert-UNION (&optional async)
  "add keyword union"
  (interactive "*p")
  (B-insert-UNION-like "UNION")
)

(defun B-insert-INTER (&optional async)
  "add keyword inter"
  (interactive "*p")
  (B-insert-UNION-like "INTER")
)

(defun B-insert-and (&optional async)
  "add keyword &"
  (interactive "*p")
  (B-insert-between-spaces "&")
)

(defun B-insert-or (&optional async)
  "add keyword or"
  (interactive "*p")
  (B-insert-between-spaces "or")
) 

(defun B-insert-imply (&optional async)
  "add keyword =>"
  (interactive "*p")
  (B-insert-between-spaces "=>")
)

(defun B-insert-equiv (&optional async)
  "add keyword <=>"
  (interactive "*p")
  (B-insert-between-spaces "<=>")
)

(defun B-insert-not (&optional async)
  "add keyword not"
  (interactive "*p")
  (B-insert-pow-like "not")
)

(defun B-insert-forall (&optional async)
  "add keyword !"
  (interactive "*p")
  (B-insert-forall-like "!")
)

(defun B-insert-exists  (&optional async)
  "add keyword #"
  (interactive "*p")
  (B-insert-forall-like "#")
)

(defun B-insert-inverse (&optional async)
  "add keyword ~"
  (interactive "*p")
  (insert "~" )
  (x-symbol-decode)
)
(defun B-insert-membership(&optional async)
  "add keyword :"
  (interactive "*p")
  (B-insert-between-spaces ":")
)	

(defun B-insert-bin-inter (&optional async)
  "add keyword /\\"
  (interactive "*p")
  (B-insert-between-spaces "/\\")
)	

(defun B-insert-bin-union (&optional async)
  "add keyword \//"
  (interactive "*p")
  (B-insert-between-spaces "\//")
)

(defun B-insert-inclu (&optional async)
  "add keyword <:"
  (interactive "*p")
  (B-insert-between-spaces "<:")
)

(defun B-insert-non-inclu (&optional async)
  "add keyword /<:"
  (interactive "*p")
  (B-insert-between-spaces "/<:" )
)

(defun B-insert-strict-inclu (&optional async)
  "add keyword <<:"
  (interactive "*p")
  (B-insert-between-spaces "<<:"  )
)

(defun B-insert-non-strict-inclu (&optional async)
  "add keyword  /<<:"
  (interactive "*p")
  (B-insert-between-spaces "/<<:" )
)

(defun B-insert-relation (&optional async)
  "add keyword <->"
  (interactive "*p")
  (B-insert-between-spaces "<->")
)

(defun B-insert-pfunc (&optional async)
  "add keyword +->"
  (interactive "*p")
  (B-insert-between-spaces "+->")
)

(defun B-insert-func (&optional async)
  "add keyword -->"
  (interactive "*p")
  (B-insert-between-spaces "-->")
)
(defun B-insert-pinto (&optional async)
  "add keyword >+>"
  (interactive "*p")
  (B-insert-between-spaces ">+>")
)

(defun B-insert-into (&optional async)
  "add keyword >->"
  (interactive "*p")
  (B-insert-between-spaces ">->")
)
(defun B-insert-poutto (&optional async)
  "add keyword +->>"
  (interactive "*p")
  (B-insert-between-spaces "+->>")
)

(defun B-insert-outto (&optional async)
  "add keyword -->>"
  (interactive "*p")
  (B-insert-between-spaces "-->>")
)

(defun B-insert-bijection (&optional async)
  "add keyword >->>"
  (interactive "*p")
  (B-insert-between-spaces ">->>")
)

(defun B-insert-overwrite (&optional async)
  "add keyword <+"
  (interactive "*p")
  (B-insert-between-spaces "<+")
)

(defun B-insert-restriction (&optional async)
  "add keyword <|"
  (interactive "*p")
  (B-insert-between-spaces "<|")
)

(defun B-insert-anti-restriction (&optional async)
  "add keyword <<|"
  (interactive "*p")
  (B-insert-between-spaces "<<|")
)

(defun B-insert-co-restriction (&optional async)
  "add keyword |>"
  (interactive "*p")
  (B-insert-between-spaces "|>")
)

(defun B-insert-co-anti-restriction (&optional async)
  "add keyword |>>"
  (interactive "*p")
  (B-insert-between-spaces "|>>")
)

(defun B-insert-refines (&optional async)
  "add keyword REFINES"
  (interactive "*p")
  (insert "\nREFINES\n   ")
)

(defun B-insert-variables (&optional async)
  "add keyword VARIABLES"
  (interactive "*p")
  (insert "\nVARIABLES\n   ")
)
(defun B-insert-invariant (&optional async)
  "add keyword INVARIANT"
  (interactive "*p")
  (insert "\nINVARIANT\n   ")
)

(defun B-insert-events (&optional async)
  "add keyword EVENTS"
  (interactive "*p")
  (insert "\nEVENTS\n   ")
)
(defun B-insert-sets (&optional async)
  "add keyword SETS"
  (interactive "*p")
  (insert "\nSETS\n   ")
)
(defun B-insert-properties (&optional async)
  "add keyword PROPERTIES"
  (interactive "*p")
  (insert "\nPROPERTIES\n   ")
)

(defun B-insert-assertions (&optional async)
  "add keyword ASSERTIONS"
  (interactive "*p")
  (insert "\nTHEOREMS\n   ")
)

(defun B-insert-definitions (&optional async)
  "add keyword DEFINITIONS"
  (interactive "*p")
  (insert "\nDEFINITIONS\n   ")
)

(defun B-insert-initialisation (&optional async)
  "add keyword INITIALISATION"
  (interactive "*p")
  (insert "\nINITIALISATION\n   ")
)
(defun B-insert-constants (&optional async)
  "add keyword CONSTANTS"
  (interactive "*p")
  (insert "\nCONSTANTS\n   ")
)

(defun B-insert-comment (&optional async)
  "add keywords begin end"
  (interactive "*p")
  (insert "\n  /*     */\n")(backward-char-command 7)
)

(defun B-insert-begin-end (&optional async)
  "add keywords begin end"
  (interactive "*p")
  (insert "\n   BEGIN\n    \n   END")(previous-line 1)
)

(defun  B-insert-such (&optional async)
  "add keywords begin end"
  (interactive "*p")
  (insert "\n     :| (   )")(backward-char-command 9)
)
 
(defun B-insert-select (&optional async)
  "add a select"
  (interactive "*p")
  (insert "\n   WHEN\n    \n   THEN\n    \n   END")(previous-line 3)
)

(defun B-insert-any (&optional async)
  "add an any"
  (interactive "*p")
  (insert "\n   ANY\n    \n   WHERE\n    \n   THEN\n    \n   END")(previous-line 5)
)

(defun B-insert-begin-end-ln (&optional async)
  "add keywords begin end"
  (interactive "*p")
  (insert "\n   BEGIN   END")(backward-char-command 5)
)

(defun B-insert-select-ln (&optional async)
  "add a select"
  (interactive "*p")
  (insert "\n   WHEN   THEN   END")(backward-char-command 12)
)

(defun B-insert-any-ln (&optional async)
  "add an any"
  (interactive "*p")
  (insert "\n   ANY   WHERE   THEN   END")(backward-char-command 20)
)

(defun B-refresh()
 (interactive)
 (x-symbol-encode)(x-symbol-decode)
)
(eval-and-compile
(defun pri-change-exit-emacs-menu ()
  "modifie le menu File->Exit XEmacs... pourqu'il appelle la fonction pri-exit"
  (add-menu-button '("File") ["Exit XEmacs" pri-exit t])))




(eval-and-compile
(defun pri-machines-mode ()
  "Mode de preuve interactive"
  (interactive)
  (kill-all-local-variables)
  (make-face 'pri-machines-red-bold-face)
  (make-face 'pri-machines-test-bold-face)
  (make-face 'pri-machines-red-face)
 (make-face 'pri-machines-blue-face) 
 (make-face 'pri-machines-blue-bold-face)
  (make-face 'pri-machines-button-red-face)
  (make-face 'pri-machines-button-blue-face)
  (custom-set-faces
   '(pri-machines-red-bold-face ((((class color))  (:foreground "red"))))
   '(pri-machines-red-face ((((class color))  (:foreground "red"))))
   '(pri-machines-blue-face ((((class color))  (:foreground "blue")))) 
   '(pri-machines-blue-bold-face ((((class color))  (:foreground "blue")))) 
   '(pri-machines-test-bold-face ((((class color))  (:foreground "black"))));; '(pri-machines-button-red-face ((t  (:bold t) (:foreground "red"))))
; '(font-lock-comment-face ((((class color) (background light)) (:foreground "blue" :background "gray85"))))
 '(font-lock-comment-face ((((class color) (background light)) (:foreground "blue"))))
)
  (make-face-bold 'pri-machines-red-bold-face)
  (make-face-bold 'pri-machines-blue-bold-face)
  (make-face-bold 'pri-machines-test-bold-face)
 (copy-face 'widget-button-face 'pri-machines-button-red-face)
(set-face-foreground 'pri-machines-button-red-face"red")
 (copy-face 'widget-button-face 'pri-machines-button-blue-face)
(set-face-foreground 'pri-machines-button-blue-face"blue")

;;   '(pri-machines-inverse-face ((((class color)) (:foreground "white" :background "black")))))
  (setq major-mode 'pri-machines-mode)
  (setq mode-name "PRI")

  (run-hooks 'pri-machines-mode-hook)
  (turn-on-font-lock)

  (set-syntax-table B-mode-syntax-table)

  (if pri-machines-mode-map
	  nil
	(setq pri-machines-mode-map (make-sparse-keymap))
	;; avant de quitter emacs on quit le prouveur interactif
	(define-key pri-machines-mode-map "\C-x\C-s" 'cansell-save-buffer)
	(define-key pri-machines-mode-map "\C-ci" 'B-insert-invariant)
	(define-key pri-machines-mode-map "\C-ce" 'B-insert-events)
	(define-key pri-machines-mode-map "\C-cd" 'B-insert-definitions)
	(define-key pri-machines-mode-map "\C-cs" 'B-insert-sets)
	(define-key pri-machines-mode-map "\C-ct" 'B-insert-initialisation)
	(define-key pri-machines-mode-map "\C-ca" 'B-insert-assertions)
	(define-key pri-machines-mode-map "\C-cp" 'B-insert-properties)
	(define-key pri-machines-mode-map "\C-cw" 'B-insert-select)
	(define-key pri-machines-mode-map "\C-cb" 'B-insert-begin-end)
	(define-key pri-machines-mode-map "\C-cy" 'B-insert-any)
	(define-key pri-machines-mode-map "\C-c\C-w" 'B-insert-select-ln)
	(define-key pri-machines-mode-map "\C-c\C-b" 'B-insert-begin-end-ln)
	(define-key pri-machines-mode-map "\C-c\C-y" 'B-insert-any-ln)
	(define-key pri-machines-mode-map "\C-cv" 'B-insert-variables)
	(define-key pri-machines-mode-map "\C-cm" 'B-insert-comment)
	(define-key pri-machines-mode-map "\C-cc" 'B-insert-constants)
	(define-key pri-machines-mode-map "\C-cn" 'B-insert-natural)
	(define-key pri-machines-mode-map "\C-c1" 'B-insert-natural1)
	(define-key pri-machines-mode-map "\C-cz" 'B-insert-integer)
	(define-key pri-machines-mode-map "\C-cB" 'B-insert-bool)
	(define-key pri-machines-mode-map "\C-cr" 'B-insert-refines)
	(define-key pri-machines-mode-map "\C-c!" 'B-insert-forall)
	(define-key pri-machines-mode-map "\C-c#" 'B-insert-exists)
	(define-key pri-machines-mode-map "\C-l" 'B-refresh)
        (define-key pri-machines-mode-map "\M-/" 'dabbrev-expand)
        (define-key global-map "\C-x\C-s" 'undefined)	)
  (use-local-map  pri-machines-mode-map)
 
 (pri-change-save-emacs-menu)
 (pri-machines-create-menu)
 ;;(substitute-key-definition 
;; 'save-buffer 'cansell-save-buffer pri-machines-mode-map global-map)

;;  (use-local-map pri-machines-mode-map)

 ;; (pri-toolbar)
 (setq truncate-lines t) 
  (setq buffer-read-only nil)
 (setq inhibit-read-only t)
 ))



(provide 'pri-machines-mode)