;******************************* STERIA **************************************
; Fichier : $Id: pri-main.el,v 1.18 2000/11/03 10:46:31 clb Exp $
;
; (C) 2000 STERIA
;
; Description : Programme principal
;               
; Auteur(s) :  clb
;
; Historique : $Log: pri-main.el,v $
; Historique : Revision 1.18  2000/11/03 10:46:31  clb
; Historique : Correction du bug 2630 : cannot switch in mini-buffer window.
; Historique :
; Revision 1.17  2000/10/27  13:58:38  clb
; Possibilite de tuer le buffer des hypotheses.
; Variable customizable pri-hypothesis-buffer-p.
;
; Revision 1.16  2000/10/27  10:36:33  clb
; Le buffer *scratch* n'est plus en mode PRI.
; Correction des C-x C-c et File->Exit Emacs.
;
; Historique : Revision 1.15  2000/10/26 09:08:23  clb
; Historique : Vidage du buffer pri-log au changement de PO.
; Historique : Rattrappage des erreurs en cas de lock sur le composant choisi.
; Historique :
; Revision 1.14  2000/10/24  13:23:34  clb
; correction de la valeur de PRI-PROCESS en version 3.6 de l'AtelierB.
;
; Historique : Revision 1.13  2000/10/24 08:09:30  clb
; Historique : Modification des messages pour la version 3.6 de l'AtelierB.
; Historique :
; Historique : Revision 1.12  2000/10/13 08:01:05  clb
; Historique : correction du bug sur la fenetre OLD-PROOF.
; Historique : rattrappage des messages de parsing du kernel.
; Historique : possibilite de lancer l'interface avec une option. ex: extra_large.
; Historique :
; Historique : Revision 1.11  2000/10/12 13:51:55  clb
; Historique : Suppression de la fenetre global situation :
; Historique : les infos se retrouvent dans la ligne de mode (modeline).
; Historique :
; Historique : Revision 1.10  2000/10/10 16:03:49  clb
; Historique : Ajout du bouton Exit dans la fenetre des composants.
; Historique : Exit dans le mode de preuve interactive revient a la liste des composants.
; Historique :
; Historique : Revision 1.9  2000/10/10 13:05:37  clb
; Historique : modification du script emaspri :
; Historique : ATELIERB_VERSION=version 3.5 ou 3.6 de l'atelier.
; Historique : ATELIERB_DIR=directory de l'executable startBB
; Historique :
; Revision 1.8  2000/10/03  12:46:08  clb
; Ajout des tampons de liste des projets et des composants.
; Ils permettent a l'utilisateur de choisir plus facilement
; le projet et le composant voulu.
;
; Revision 1.7  2000/10/02  13:23:29  clb
; Suppression de la fenetre terminal.
; C'est le minibuffer qui sert de terminal.
; Revue des autoloads suite a la compilation de tous les fichiers.
; La seule fenetre au debut est la fenetre Log.
; Correction de pri-version qui etait defini deux fois differements.
; Ajout du fichier pri-traces.el
;
; Revision 1.6  2000/09/28  14:48:57  clb
; pri-terminal-print => pri-log-print (pri-terminal.el => pri-log.el)
;
; Revision 1.5  2000/09/26  14:39:47  clb
; ajout d'un mode trace pour le debug.
; pri-trace ==> pri-terminal-print.
; enlevement du autoload de pri-trace aux endroits inutiles.
;
; Revision 1.4  2000/09/22  13:50:16  clb
; Gestion des fenetres : retrecissement des fenetres de gauches.
;
; Historique : Revision 1.3  2000/09/22 12:28:35  clb
; Historique : nouvelle organisation des fenetres.
; Historique :
; Revision 1.2  2000/06/30  09:37:45  clb
; ajout des entetes de fichiers
;
;
;*****************************************************************************
;;"include a la lisp"
(autoload 'pri-projects-list-mode "pri-projects-list.el")
(autoload 'pri-version "pri-version.el")
(autoload 'pri-component-change-exit-emacs-menu "pri-components-list.el")
(autoload 'pri-errors-mode "pri-errors")
(autoload 'pri-machines-mode "pri-machines-mode")
;;(require 'pri-machines-mode)
;;*****************************************************************************
;;zone de declaration des variables globales
;;*****************************************************************************
;;*****************************************************************************
;;nom du process "prouveur"
(eval-and-compile
;; (if (string= pri-atelierb-version "3.6")

(defvar PRI-PROCESS (concat  pri-process-dir  "/" "bbatch  -r="pri-model-dir "/B4free.rc")
		"prouveur interactif de l'atelier B")

;;(defvar PRI-PROCESS (concat pri-process-dir "/AB/bbin/" "startBB.emacspri") "prouveur interactif de l'atelier B"))
(defvar PRI-MODELE-dir pri-model-dir)
(defvar PRI-PROMPT "PRI> " "prompt du proveur interactif"))

;;*****************************************************************************
;;constantes representant les noms des buffers utilises
(eval-and-compile
(defvar PRI-GOAL "pri-goal" "")
(defvar PRI-HYPOTHESIS "pri-hypothesis" "")
(defvar PRI-OLD-PROOF "pri-old-proof" "")
(defvar PRI-PROOF-TREE "pri-proof-tree" "")
(defvar PRI-PO-LIST "pri-po-list")
(defvar PRI-LOG "pri-log" "")
(defvar PRI-PROJECTS-LIST "pri-projects-list" "")
(defvar PRI-COMPONENTS-LIST "pri-components-list" ""))

;;*****************************************************************************
(eval-and-compile
(defvar pri-memory (cons 1 nil) "tampon de reception des sorties du prouveur")

(defvar pri-operation-name nil "Nom de l'operation"))

;;*****************************************************************************
(eval-and-compile
(defvar pri-goal-window nil "")
(defvar pri-hypothesis-window nil "")
(defvar pri-proof-tree-window nil "")
(defvar pri-old-proof-window nil "")
(defvar pri-po-list-window nil "")
(defvar pri-log-window nil "")
(defvar pri-projects-list-window nil "")
(defvar pri-components-list-window nil ""))
(defvar pri-old-buffer nil "")
(defvar pri-error-list-window nil "")


;;*****************************************************************************
;;fin de zone de declaration des variables globales
;;*****************************************************************************
(eval-and-compile
(defun pri-stop ()
(setq cansell-exist-le-champs nil)
(setq   cansell-dans-error t)
  (if (get-buffer PRI-GOAL)
	  (kill-buffer PRI-GOAL))
  (if (get-buffer PRI-HYPOTHESIS)
	  (kill-buffer PRI-HYPOTHESIS))
;;(if cansell-calculette (cansell-delete-prompt-pri))
  (if (get-buffer "pri-rs")  (kill-buffer "pri-rs"))
  (if (get-buffer PRI-LOG)  (kill-buffer PRI-LOG))
  (if (get-buffer PRI-OLD-PROOF)   (kill-buffer PRI-OLD-PROOF))
  (if (get-buffer PRI-PROOF-TREE)  (kill-buffer PRI-PROOF-TREE))
  (if (get-buffer PRI-PO-LIST)   (kill-buffer PRI-PO-LIST))

  (pop-to-buffer PRI-COMPONENTS-LIST nil cansell-proj-frame) 
   (delete-other-windows)		   
  (pop-to-buffer "pri-errors" t cansell-error-frame) 
   (delete-other-windows)
 (if cansell-not-pb-p (setq cansell-envoi-sml t) (progn (setq cansell-not-pb-p t)(cansell-affiche-composant)))
 ;;(set-default-toolbar-position 'bottom)
  (pri-component-change-exit-emacs-menu)
(setq cansell-beginner nil) 
))


;(require 'B-mode)
(defcustom x-symbol-B-name "B entity"
  "Standard name of token language `B'.
See language access `x-symbol-LANG-name'."
  :group 'x-symbol-B
  :type 'string)

(defcustom x-symbol-B-modes
  '(pri-machines-mode)
  ;;'(tex-mode latex-mode plain-tex-mode noweb-mode)
  "Major modes typically using X-Symbol with language `B'.
See language access `x-symbol-LANG-modes'."
  :group 'x-symbol-B
  :group 'x-symbol-mode
  :type '(repeat function))


(defcustom x-symbol-B-prover-name "B prover"
  "Standard name of token language (prover)  `B'.
See language access `x-symbol-LANG-name'."
  :group 'x-symbol-B-prover
  :type 'string)

(defcustom x-symbol-B-prover-modes
  '(pri-atelierb-mode)
  ;;'(tex-mode latex-mode plain-tex-mode noweb-mode)
  "Major modes typically using X-Symbol with language `B'.
See language access `x-symbol-LANG-modes'."
  :group 'x-symbol-B-prover
  :group 'x-symbol-mode
  :type '(repeat function))





;;*****************************************************************************
(eval-and-compile
(defun pri-start  ()
  (interactive)

(x-symbol-register-language 'B 'x-symbol-B x-symbol-B-modes)
(x-symbol-register-language 'Bprover 'x-symbol-B-prover x-symbol-B-prover-modes)

;;(setq x-symbol-default-coding 'iso-8859-1)
(x-symbol-initialize) 

(setq cansell-pri-memory   pri-memory )
;;( load-library "~/emacs/SimpleBMode.elc")

  (pri-trace ">> pri-start\n")
  ;;demarrage de startBB
  (if (get-process PRI-PROCESS)		
	  (delete-process PRI-PROCESS))

;;(shell-command "xset +fp /home/cansell/font")
;;(shell-command "xset fp rehash") 

  (pri-trace ">> pri-start2\n")
  (if (start-process-shell-command PRI-PROCESS nil PRI-PROCESS)
	  (set-process-filter (get-process PRI-PROCESS) 'pri-output-filter)
	(message (concat "Cannot start " PRI-PROCESS)))
 (add-hook 'pri-errors-mode-hook 
			'turn-on-font-lock)
			  (add-hook 'pri-atelierb-mode-hook 
				    'turn-on-font-lock) 
			  (add-hook 'pri-machines-mode-hook 
				    'turn-on-font-lock) 
 (add-hook 'pri-projects-list-mode-hook 
			'turn-on-font-lock)
  (pri-trace ">> pri-start3\n")



(setq cansell-height (- (/ (* (frame-height) (device-pixel-height)) (frame-pixel-height)) 5))
(setq cansell-width (- (/ (/ (* (frame-width) (device-pixel-width)) (frame-pixel-width)) 2) 2))

(setq cansell-top-xx (/ (frame-pixel-height)(frame-height)))
(setq cansell-top-yy  (/ (frame-pixel-width)(frame-width)))
  

(setq cansell-proj-frame  (make-frame))
   

(set-frame-position  cansell-proj-frame cansell-top-yy cansell-top-xx)
(set-frame-height cansell-proj-frame cansell-height)
(set-frame-width cansell-proj-frame cansell-width)
(redraw-frame cansell-proj-frame  t)





 (other-frame 1)
 (delete-other-frames)
 
 (pop-to-buffer PRI-PROJECTS-LIST  cansell-proj-frame )
 (delete-other-windows)
 (pri-projects-list-mode)


 (setq cansell-error-frame  (make-frame))
 (set-frame-position  cansell-error-frame (/ (device-pixel-width) 2) cansell-top-xx)
 (set-frame-height cansell-error-frame cansell-height)
 (set-frame-width cansell-error-frame cansell-width)
 (redraw-frame cansell-error-frame  t)
 (other-frame 1)

(pri-errors-mode)
;;(setq pri-error-list-window (frame-selected-window cansell-error-frame))

;;(set-window-buffer  pri-error-list-window  "pri-errors") 
;;(delete-other-windows pri-error-list-window )
(pop-to-buffer  "pri-help" cansell-error-frame) 
 (pop-to-buffer    "pri-errors"  cansell-error-frame) 
  (delete-other-windows)


(pri-before-writting-buffer  "pri-errors")   (insert  "\n\n\n\n\n\n\n\n BALBULETTE: Version : 2.0 (16 may 2005) \n\n\n\n\n\n            Jean-Raymond Abrial & Dominique Cansell" );; (sleep-for 3)
(if (featurep 'mule) (insert  "\n\n  You use xemacs mule. You'll not see all B symbols. Please install the nomule version (www.xemacs.org)."))


(pri-after-writting-buffer) 

 (pri-errors-mode)

 ;; (pop-to-buffer PRI-PROJECTS-LIST pri-projects-list-window )
;; (set-window-buffer pri-projects-list-window PRI-PROJECTS-LIST)
;;  (delete-other-windows  pri-projects-list-window )
;;(cansell-affiche-projet)	

;;  (pri-trace  pri-error-list-window)
;;(switch-to-buffer-other-window  PRI-PROJECTS-LIST)
;;(redraw-display cansell-proj-frame)
;;(redraw-display cansell-error-frame)
))


;;*****************************************************************************
(eval-and-compile
(defun pri-before-writting-buffer (buffer)
  (setq pri-old-buffer (current-buffer))
  (if (get-buffer buffer)()(find-file buffer))
  (set-buffer buffer);;(end-of-buffer)
  (setq inhibit-read-only t)
  (setq buffer-read-only nil)
))

(eval-and-compile
(defun pri-after-writting-buffer ()
 	;;(setq buffer-read-only t)
	;;(setq inhibit-read-only nil)
       ;; (end-of-buffer)
	(set-buffer pri-old-buffer)))

(provide 'main)



