;******************************* ClearSy *************************************
; Fichier : $Id: pri-messages.el,v 1.12 2001/12/12 14:04:42 clb Exp $
;
;
;  Copyright (C) 2001 CLEARSY
;
;  This file is part of EMACSPRI.
;
;
; EMACSPRI is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
;
;
; Description : Liste des messages du prouveur
;               
; Auteur(s) :  clb
;
; Historique : $Log: pri-messages.el,v $
; Revision 1.12  2001/12/12  14:04:42  clb
; Les numeros des messages ne sont plus des variables,
; mais des constantes.
; Ajout d'une numero de message max : 250.
;
; Revision 1.11  2001/12/11  13:32:54  clb
; Message de fin de session de preuve en Anglais.
;
; Revision 1.10  2001/12/05  13:48:10  clb
; Suppression des copyright STERIA 2000.
;
; Historique : Revision 1.9  2001/02/01 09:56:51  clb
; Historique : Ajout des copyright dans les commentaires des sources.
; Historique :
; Revision 1.8  2000/10/26  09:08:24  clb
; Vidage du buffer pri-log au changement de PO.
; Rattrappage des erreurs en cas de lock sur le composant choisi.
;
; Historique : Revision 1.7  2000/10/24 09:16:48  clb
; Historique : nouvelles icones pp et pp0. correction d'"autoload".
; Historique : La version V1.1.18 ne marche pas.
; Historique :
; Historique : Revision 1.6  2000/10/24 08:09:31  clb
; Historique : Modification des messages pour la version 3.6 de l'AtelierB.
; Historique :
; Historique : Revision 1.5  2000/10/10 13:05:37  clb
; Historique : modification du script emaspri :
; Historique : ATELIERB_VERSION=version 3.5 ou 3.6 de l'atelier.
; Historique : ATELIERB_DIR=directory de l'executable startBB
; Historique :
 ; Revision 1.4  2000/10/02  13:23:30  clb
; Suppression de la fenetre terminal.
; C'est le minibuffer qui sert de terminal.
; Revue des autoloads suite a la compilation de tous les fichiers.
; La seule fenetre au debut est la fenetre Log.
; Correction de pri-version qui etait defini deux fois differements.
; Ajout du fichier pri-traces.el
;
; Revision 1.3  2000/09/26  13:10:28  clb
; correction du bug 2565.
;
; Revision 1.2  2000/06/30  09:37:45  clb
; ajout des entetes de fichiers
;
;
;*****************************************************************************
;;*****************************************************************************
;;zone de declaration des variables globales
;;*****************************************************************************
;;constantes globales pour gestion des messages du prouveur
(eval-and-compile

(defconst pri-nb-max-messages 250)
;; PRI-PRV-II-NN-101 =>  PRI-PRV-II-NN-109 : utilises par le prouveur automatique
;; PRI-PRV-II-NN-110 =>  PRI-PRV-II-NN-112 : non utilises
 
(defconst PRI-PRV-II-BB-1 12 "Current PO is ")
(defconst PRI-PRV-II-M1-1 13 "Unproved saved Proved ")
(defconst PRI-PRV-II-M2-1 14 "Unproved saved Unproved ")
(defconst PRI-PRV-II-M3-1 15 "Proved saved Proved ")
(defconst PRI-PRV-II-M4-1 16 "Proved saved Unproved ")
(defconst PRI-PRV-II-M5-1 17 "message signifiant que les messages suivants representent l'arbre de preuve")
(defconst PRI-PRV-II-M6-1 18 "message signifiant que les messages suivants representent l'ancienne preuve")
(defconst PRI-PRV-II-M7-1 19 "message signifiant que les messages suivants sont de nouvelles hypotheses (qui remplacent celles existantes)")
(defconst PRI-PRV-II-M8-1 20 "message signifiant que les messages suivants constituent le but")
(defconst PRI-PRV-II-M9-1 21 "message signifiant que les messages suivants sont de nouvelles hypotheses a rajouter a celles deja existantes")
;; PRI-PRV-II-EE-1 : end (of current PO) : non affiche
(defconst PRI-PRV-II-NN-2 23 "No current PO")
(defconst PRI-PRV-II-NN-3 24 "Unknown command")
(defconst PRI-PRV-II-BB-4 25 "message signifiant que la liste des PO et leur etat va suivre")
(defconst PRI-PRV-II-M1-4 26 "message signifiant le nom d'une cathegorie de po (operation ou assertion...)")
(defconst PRI-PRV-II-M2-4 27 "message signifiant le nom et l'etat prouvee d'une po")
(defconst PRI-PRV-II-M3-4 28 "message signifiant le nom et l'etat non prouvee d'une po")
(defconst PRI-PRV-II-EE-4 29 "message signifiant toutes les po ont ete recues")
(defconst PRI-PRV-II-NN-5 30 "Already Proved")
(defconst PRI-PRV-II-NN-6 31 "No Goal to Prove")
(defconst PRI-PRV-II-NN-7 32 "No saving")
(defconst PRI-PRV-II-NN-8 33 "Last PO was Proved by a saved demo. Your new demo fails to prove.") 
(defconst PRI-PRV-II-NN-9 34 "Do you want to save the new demo (will cause regression)?")
(defconst PRI-PRV-II-NN-10 35 "  Answer Yes to save (any other word to continue without saving) ")
(defconst PRI-PRV-II-NN-11 36 "Last PO have no saved demo. Your new demo fails to prove.")
(defconst PRI-PRV-II-NN-12 37 "Do you want to save the new demo (will replace the old one)?")
(defconst PRI-PRV-II-NN-13 38 "  Answer No to continue without saving (any other word to save) ")
(defconst PRI-PRV-II-NN-14 39 "Last PO was Proved by a saved demo that DOES NOT PROVE ANYMORE")
(defconst PRI-PRV-II-NN-15 40 "Last PO was Proved by a saved demo. Your new demo also Proves.")
(defconst PRI-PRV-II-NN-16 41 "Do you want to save the new demo (will replace the old one)?")
(defconst PRI-PRV-II-NN-17 42 "  Answer Yes to save (any other word to continue without saving) ")
(defconst PRI-PRV-II-NN-18 43 "PO saved")
(defconst PRI-PRV-II-NN-19 44 "No such command")
(defconst PRI-PRV-II-NN-20 45 "Nothing to step")
(defconst PRI-PRV-II-NN-21 46 "Next step")
(defconst PRI-PRV-II-NN-22 47 "Nothing to backtrack")
(defconst PRI-PRV-II-NN-23 48 "Invalid Goto go")
(defconst PRI-PRV-II-NN-24 49 "Already on PO")
(defconst PRI-PRV-II-NN-25 50 "  No such rule")
(defconst PRI-PRV-II-NN-26 51 "  incorrect for forward use (no antecedents, bcall in rule)")
(defconst PRI-PRV-II-NN-27 52 "Rule  made no new hypothesis")
(defconst PRI-PRV-II-NN-28 53 "Mode  invalid for non rewriting rule")
(defconst PRI-PRV-II-NN-29 54 "Rewriting  made no new hypothesis")
(defconst PRI-PRV-II-NN-30 55 "Mode  invalid for rewriting rule")
(defconst PRI-PRV-II-NN-31 56 "Rule/Tactic cannot do anything")
(defconst PRI-PRV-II-NN-32 57 "Invalid expression /empty theory")
(defconst PRI-PRV-II-NN-33 58 "Interrupted Forward")
(defconst PRI-PRV-II-NN-34 59 "Interrupted Rewriting")
(defconst PRI-PRV-II-NN-35 60 "No hypothesis matching Pattern [  ]")
(defconst PRI-PRV-II-NN-36 61 "Interrupted ApplyRule")
(defconst PRI-PRV-II-NN-37 62 "Interrupted Command")
(defconst PRI-PRV-II-NN-38 63 "This Command gives nothing new")
(defconst PRI-PRV-II-NN-39 64 "No such hypothesis")
(defconst PRI-PRV-II-NN-40 65 "dd inapplicable because Goal is different from p=>q")
(defconst PRI-PRV-II-NN-41 66 "Instantiation of hyp inapplicable in ph  ")
(defconst PRI-PRV-II-NN-42 67 "Instantiation of goal inapplicable in se  ")
(defconst PRI-PRV-II-NN-43 68 "Invalid argument in eh")
(defconst PRI-PRV-II-NN-44 69 "Neither  =   nor  = exists")
(defconst PRI-PRV-II-NN-45 70 "No possible replacement of  by  in  ")
(defconst PRI-PRV-II-NN-46 71 "Invalid argument / Inexistent a=>b Hypothesis in mh")
(defconst PRI-PRV-II-NN-47 72 "Theory  Not Loaded because name clashes with native Theories  ")
(defconst PRI-PRV-II-NN-48 73 "Proof Method Manual File  incorrect / non-existent")
(defconst PRI-PRV-II-NN-49 74 "No repeated allowed")
(defconst PRI-PRV-II-NN-50 75 "Repeating")
(defconst PRI-PRV-II-NN-51 76 "Loading theory")
(defconst PRI-PRV-II-NN-52 77 "prompt pri")
(defconst PRI-PRV-II-NN-53 78 "No unreached Unproved PO")
(defconst PRI-PRV-II-NN-54 79 "Searching all hypothesis that")
(defconst PRI-PRV-II-NN-55 80 "contain")
(defconst PRI-PRV-II-NN-56 81 "match with")
(defconst PRI-PRV-II-NN-57 82 "Starting search...")
(defconst PRI-PRV-II-BB-58 83 "Found hypothesis List is")
(defconst PRI-PRV-II-EE-58 84 "End of found hypothesis")
(defconst PRI-PRV-II-NN-59 85 "No hypothesis found")
(defconst PRI-PRV-II-BB-60 86 "Reducing hypothesis of lemma")
(defconst PRI-PRV-II-M1-60 87 "  Hypothesis   pass(es) of inclusion by common symbols from goal")
(defconst PRI-PRV-II-EE-60 88 "End of reduced PO")
(defconst PRI-PRV-II-NN-62 89 "Invalid argument, should be a number in rp ( )")
(defconst PRI-PRV-II-NN-63 90 "No PO to reduce rp")
(defconst PRI-PRV-II-NN-64 91 "Invalid Goto without save gw")
(defconst PRI-PRV-II-NN-65 92 "Skipping without saving to")
(defconst PRI-PRV-II-NN-66 93 "Nothing to Save")
(defconst PRI-PRV-II-NN-67 94 "Incorrect Force pleas use a number")
;; PRI-PRV-II-NN-68 : non utilise
(defconst PRI-PRV-II-NN-69 96 "Switching to Force")
(defconst PRI-PRV-II-NN-70 97 "Already on Force")
(defconst PRI-PRV-II-NN-71 98 "Please Enter one PO before changing Force")
(defconst PRI-PRV-II-NN-72 99 "Prover call did nothing")
(defconst PRI-PRV-II-NN-73 100 "Interrupted prover call")
(defconst PRI-PRV-II-NN-74 101 "Execution Aborted in Prover!")
(defconst PRI-PRV-II-NN-75 102 "Starting Prover Call")
(defconst PRI-PRV-II-NN-76 103 "Starting Add Hypothesis")
(defconst PRI-PRV-II-NN-77 104 "Starting Do Cases")
(defconst PRI-PRV-II-NN-78 105 "Starting False Hypothesis")
(defconst PRI-PRV-II-NN-79 106 "Starting Deduction")
(defconst PRI-PRV-II-NN-80 107 "Starting Modus Ponens on Hypothesis")
(defconst PRI-PRV-II-NN-81 108 "Starting Particularize Hypothesis")
(defconst PRI-PRV-II-NN-82 109 "Starting Suggest for Exist")
(defconst PRI-PRV-II-NN-83 110 "Starting use Equality in Hypothesis")
(defconst PRI-PRV-II-NN-84 111 "Starting Contradiction")
(defconst PRI-PRV-II-NN-85 112 "Starting Apply rule")
;; PRI-PRV-II-NN-86 : non utilise
(defconst PRI-PRV-II-NN-87 114 "Resetting PO")
(defconst PRI-PRV-II-NN-88 115 "No PO to Reset")
(defconst PRI-PRV-II-NN-89 116 "No demo to save")
(defconst PRI-PRV-II-NN-90 117 "Cannot Do Cases on Enumerated, should be a variable")
(defconst PRI-PRV-II-NN-91 118 "Do Cases on Enumerated")
(defconst PRI-PRV-II-NN-92 119 "Cannot Do Cases on Enumerated,  should be a variable")
;; PRI-PRV-II-NN-93 => PRI-PRV-II-NN-99 : non utilise
;; PRI-PRV-II-BB-100 et PRI-PRV-II-EE-100 : messages vides
;; PRI-PRV-II-NN-150 => PRI-PRV-II-NN-158 : inutilises


(defconst PRI-PRV-II-NN-159 138 "Starting search...")
;; PRI-PRV-II-NN-160 : non utilise
(defconst PRI-PRV-II-NN-161 140 "Rule list is")
(defconst PRI-PRV-II-EE-162 141 "End of rule list")
;; PRI-PRV-II-NN-163 => PRI-PRV-II-NN-175 : non utilise
;; PRI-PRV-II-NN-176 : a voir
(defconst PRI-PRV-II-NN-177 158 "Invalid SearchRule")
(defconst PRI-PRV-II-NN-178 159 "Invalid SearchRule, cannot use pattern with Goal")
(defconst PRI-PRV-II-EE-179 160 "Found 0 rule(s) for this filter")
(defconst PRI-PRV-II-BB-180 161 "Searching rules matching with goal in")
(defconst PRI-PRV-II-BB-181 162 "Searching in  rules with filter")
(defconst PRI-PRV-II-M1-182 163 " consequent should contain")
(defconst PRI-PRV-II-M2-183 164 " consequent should match with")
(defconst PRI-PRV-II-M3-184 165 " antecedent should contain")
(defconst PRI-PRV-II-M4-185 166 " antecedent should match with")
(defconst PRI-PRV-II-NN-186 167 "No PO to show for lp")
(defconst PRI-PRV-II-BB-187 168 "Show PO")
(defconst PRI-PRV-II-EE-187 169 "End PO")
(defconst PRI-PRV-EE-NN-188 170 "  is an invalid value for m1")
(defconst PRI-PRV-EE-NN-189 171 "  is an invalid value for m2")
(defconst PRI-PRV-EE-NN-190 172 "  is an invalid value for m3")
(defconst PRI-PRV-EE-NN-191 173 "You must choose a PO")
(defconst PRI-PRV-EE-NN-192 174 "Invalid list of commands")
(defconst PRI-PRV-II-NN-193 175 "Begin TryEveryWhere")
(defconst PRI-PRV-II-NN-194 176 "--- Working on")
(defconst PRI-PRV-II-NN-195 177 "Summary")
(defconst PRI-PRV-II-NN-196 178 "transformed  --> Proved")
(defconst PRI-PRV-II-NN-197 179 "End TryEveryWhere")
(defconst PRI-PRV-II-BB-198 180 "Help")
(defconst PRI-PRV-II-EE-198 181 "End help")
(defconst PRI-PRV-EE-NN-199 182 "The last argument must be an integer")
;; PRI-PRV-EE-NN-200 : non u5ilise 
(defconst PRI-PRV-EE-NN-201 184 "Invalid rule patern")
(defconst PRI-PRV-EE-NN-202 185 "The type of the rule must be Back / Fwd")
;; PRI-PRV-EE-NN-203 et PRI-PRV-8E-NN-204 : non utilises
(defconst PRI-PRV-II-NN-205 188 "The proof of the rule failed")
(defconst PRI-PRV-II-NN-206 189 "The rule was proved")
;; PRI-PRV-EE-NN-207 et PRI-PRV-EE-NN-208 : non utilises
(defconst PRI-PRV-II-NN-209 192 "Interrupted")
;; PRI-PRV-EE-NN-210 => PRI-PRV-EE-NN-213 : non utilises
(defconst PRI-PRV-EE-NN-214 199 "Failure in the Predicate Prover")
(defconst PRI-PRV-II-NN-215 200 "Starting Predicate Prover Call")
(defconst PRI-PRV-II-NN-216 201 "The Predicate Prover went out of time")
(defconst PRI-PRV-II-NN-217 202 "The Predicate Prover failed to prove the current goal")
(defconst PRI-PRV-II-NN-218 203 "Proved by the Predicate Prover")
(defconst PRI-PRV-II-NN-219 204 "Invalid argument  should be an integer")
(defconst PRI-PRV-II-NN-220 205 "Invalid theory  should be in rule base")
;; PRI-PRV-EE-NN-221 et PRI-PRV-EE-NN-250 : non utilises
(defconst PRI-PRV-II-BB-251 208 "Starting Trace in mode ")
(defconst PRI-PRV-II-EE-251 209 "End of Trace")
(defconst PRI-PRV-II-M1-252 210 "\n  Press RETURN key")
;; PRI-PRV-EE-NN-222 : utilise par le prouveur automatique
(defconst PRI-PRV-II-NN-223 212 "Starting tentative proof")
(defconst PRI-PRV-II-NN-224 213 "No rule to use")
(defconst PRI-PRV-II-NN-225 214 "Starting creating hyp")
(defconst PRI-PRV-II-NN-226 215 "+")
(defconst PRI-PRV-II-NN-227 216 "-")
(defconst PRI-PRV-II-NN-253 217 "Begin Arithmetic Proof")
(defconst PRI-PRV-EE-NN-254 218 "Invalid argument: must be a numeric value")
(defconst PRI-PRV-II-NN-255 219 "Begin SimplifySet")
(defconst PRI-PRV-II-NN-256 220 "Impossible to translate the rule")
(defconst PRI-PRV-II-NN-257 221 "Typecheck error")
(defconst PRI-PRV-II-NN-258 222 ">>> Theory is non-existent <<<")
(defconst PRI-PRV-II-NN-259 223 "End of proof session")


;; Messages lies a l'analyseur de formules
(defconst PRI-PRV-II-NN-260 224 "Unable to analyze formula")
(defconst PRI-PRV-II-NN-261 225 "Unable to analyze predicate")
(defconst PRI-PRV-II-NN-262 226 "Unable to analyze expression ")
(defconst PRI-PRV-II-BB-263 227 "Parsing formula")
(defconst PRI-PRV-II-EE-264 228 "End of analysis")
(defconst PRI-PRV-II-NN-265 229 "Term not found")
(defconst PRI-PRV-II-NN-266 230 "is put for")
(defconst PRI-PRV-II-NN-267 231 "No term to display")

;; Messages lies au systeme de trace graphique
(defconst PRI-PRV-EE-NN-300 232 "Invalid parameter Should be on or off")
(defconst PRI-PRV-II-NN-301 233 "Graphical Trace mode is on")
(defconst PRI-PRV-II-NN-302 234 "Graphical Trace mode is off")
(defconst PRI-PRV-II-NN-303 235 "Rewind your demo to start displaying the graphical trace")

(defconst PRI-PRV-II-NN-304 236 "new graph")
(defconst PRI-PRV-II-NN-305 237 "delete node")
(defconst PRI-PRV-II-NN-306 238 "add node")
(defconst PRI-PRV-II-NN-307 239 "add edge")
(defconst PRI-PRV-II-NN-308 240 "modify node attributes")
(defconst PRI-PRV-II-NN-309 241 "modify edge attributes")
(defconst PRI-PRV-II-NN-310 242 "Improve all")
(defconst PRI-PRV-II-NN-311 243 "Message comme on veut avec un seul param")


(defconst pri-messages-list
  (list  PRI-PRV-II-NN-3 PRI-PRV-II-NN-5 PRI-PRV-II-NN-6
		 PRI-PRV-II-NN-7 PRI-PRV-II-NN-8 PRI-PRV-II-NN-9
		 PRI-PRV-II-NN-10 PRI-PRV-II-NN-11 PRI-PRV-II-NN-12
		 PRI-PRV-II-NN-13 PRI-PRV-II-NN-14 PRI-PRV-II-NN-15
		 PRI-PRV-II-NN-16 PRI-PRV-II-NN-17 PRI-PRV-II-NN-18
		 PRI-PRV-II-NN-19 PRI-PRV-II-NN-20 PRI-PRV-II-NN-21
		 PRI-PRV-II-NN-22 PRI-PRV-II-NN-23 PRI-PRV-II-NN-24
		 PRI-PRV-II-NN-25 PRI-PRV-II-NN-26 PRI-PRV-II-NN-27
		 PRI-PRV-II-NN-28 PRI-PRV-II-NN-29 PRI-PRV-II-NN-30
		 PRI-PRV-II-NN-31 PRI-PRV-II-NN-32 PRI-PRV-II-NN-33
		 PRI-PRV-II-NN-34 PRI-PRV-II-NN-35 PRI-PRV-II-NN-36
		 PRI-PRV-II-NN-37 PRI-PRV-II-NN-38 PRI-PRV-II-NN-39
		 PRI-PRV-II-NN-40 PRI-PRV-II-NN-41 PRI-PRV-II-NN-42
		 PRI-PRV-II-NN-43 PRI-PRV-II-NN-44 PRI-PRV-II-NN-45
		 PRI-PRV-II-NN-46 PRI-PRV-II-NN-47 PRI-PRV-II-NN-48
		 PRI-PRV-II-NN-49 PRI-PRV-II-NN-50 PRI-PRV-II-NN-51
		 PRI-PRV-II-NN-54 PRI-PRV-II-NN-55 PRI-PRV-II-NN-56
		 PRI-PRV-II-NN-57 PRI-PRV-II-BB-58 PRI-PRV-II-EE-58
		 PRI-PRV-II-NN-59 PRI-PRV-II-BB-60 PRI-PRV-II-M1-60
		 PRI-PRV-II-EE-60 PRI-PRV-II-NN-62 PRI-PRV-II-NN-63
		 PRI-PRV-II-NN-64 PRI-PRV-II-NN-65 PRI-PRV-II-NN-66
		 PRI-PRV-II-NN-67 PRI-PRV-II-NN-69 PRI-PRV-II-NN-70
		 PRI-PRV-II-NN-71 PRI-PRV-II-NN-72 PRI-PRV-II-NN-73
		 PRI-PRV-II-NN-74 PRI-PRV-II-NN-75 PRI-PRV-II-NN-76
		 PRI-PRV-II-NN-77 PRI-PRV-II-NN-78 PRI-PRV-II-NN-78
		 PRI-PRV-II-NN-79 PRI-PRV-II-NN-80 PRI-PRV-II-NN-81
		 PRI-PRV-II-NN-82 PRI-PRV-II-NN-83 PRI-PRV-II-NN-84
		 PRI-PRV-II-NN-85 PRI-PRV-II-NN-87 PRI-PRV-II-NN-88
		 PRI-PRV-II-NN-89 PRI-PRV-II-NN-90 PRI-PRV-II-NN-91
		 PRI-PRV-II-NN-92 PRI-PRV-II-NN-159 PRI-PRV-II-NN-161
		 PRI-PRV-II-EE-162 PRI-PRV-II-NN-177 PRI-PRV-II-NN-178
		 PRI-PRV-II-EE-179 PRI-PRV-II-BB-180 PRI-PRV-II-BB-181
		 PRI-PRV-II-M1-182 PRI-PRV-II-M2-183 PRI-PRV-II-M3-184
		 PRI-PRV-II-M4-185 PRI-PRV-II-NN-186 PRI-PRV-II-BB-187
		 PRI-PRV-II-EE-187 PRI-PRV-EE-NN-188 PRI-PRV-EE-NN-189
		 PRI-PRV-EE-NN-190 PRI-PRV-EE-NN-191 PRI-PRV-EE-NN-192
		 PRI-PRV-II-NN-193 PRI-PRV-II-NN-194 PRI-PRV-II-NN-195
		 PRI-PRV-II-NN-196 PRI-PRV-II-NN-197 PRI-PRV-II-BB-198
		 PRI-PRV-II-EE-198 PRI-PRV-EE-NN-199 PRI-PRV-EE-NN-201
		 PRI-PRV-EE-NN-202 PRI-PRV-II-NN-205 PRI-PRV-II-NN-206
		 PRI-PRV-II-NN-209 PRI-PRV-EE-NN-214 PRI-PRV-II-NN-215
		 PRI-PRV-II-NN-216 PRI-PRV-II-NN-217 PRI-PRV-II-NN-218
		 PRI-PRV-II-NN-219 PRI-PRV-II-NN-220 PRI-PRV-II-M1-252
		 PRI-PRV-II-NN-223 PRI-PRV-II-NN-224 PRI-PRV-II-NN-225
		 PRI-PRV-II-NN-226 PRI-PRV-II-NN-227 PRI-PRV-II-M1-252
		 PRI-PRV-II-NN-223 PRI-PRV-II-NN-224 PRI-PRV-II-NN-225
		 PRI-PRV-II-NN-226 PRI-PRV-II-NN-227 PRI-PRV-II-NN-253
		 PRI-PRV-EE-NN-254 PRI-PRV-II-NN-255 PRI-PRV-II-NN-256 
		 PRI-PRV-II-NN-257 PRI-PRV-II-NN-258))

(defconst pri-question-messages-list
  (list PRI-PRV-II-NN-10 PRI-PRV-II-NN-13 PRI-PRV-II-NN-17)))
