;******************************* STERIA **************************************
; Fichier : $Id: pri-po-state.el,v 1.21 2000/11/07 14:51:23 clb Exp $
;
; (C) 2000 STERIA
;
; Description : Gestion de l'etat des POs
;               
; Auteur(s) :  clb
;
; Historique : $Log: pri-po-state.el,v $
; Historique : Revision 1.21  2000/11/07 14:51:23  clb
; Historique : Les boutons des POs sont maintenant tout le temps selectionnables.
; Historique : On ne switche du buffer des PO vers le buffer pri-log que si
; Historique : le buffer n'est pas visible.
; Historique :
; Revision 1.20  2000/11/03  13:54:12  clb
; Nouveau Menu PRI : item Customize, Save, About Emacspri, Exit.
;
; Revision 1.19  2000/11/03  10:36:54  clb
; Correction du nom du composant : TAB en moins.
; modification de l'etat de la PO courante : on n'a plus saved...
;
; Revision 1.18  2000/10/27  15:04:20  clb
; Correction des problemes de curseur :
; il va en debut de buffer dans les liste des projets/composants/pos,
; et en fin de buffer pour pri-log.
;
; Revision 1.17  2000/10/27  10:36:34  clb
; Le buffer *scratch* n'est plus en mode PRI.
; Correction des C-x C-c et File->Exit Emacs.
;
; Revision 1.16  2000/10/26  12:58:50  clb
; Le Try Everywhere ne saut plus une ligne a chaque +/-.
; On ne vide plus le buffer log au changement de PO :
; ca vidait le buffer en fin de tryeverywhere,
; du coup on n'avait pas les resultats .
;
; Historique : Revision 1.15  2000/10/26 09:08:24  clb
; Historique : Vidage du buffer pri-log au changement de PO.
; Historique : Rattrappage des erreurs en cas de lock sur le composant choisi.
; Historique :
; Historique : Revision 1.14  2000/10/24 09:16:48  clb
; Historique : nouvelles icones pp et pp0. correction d'"autoload".
; Historique : La version V1.1.18 ne marche pas.
; Historique :
; Historique : Revision 1.13  2000/10/24 08:09:32  clb
; Historique : Modification des messages pour la version 3.6 de l'AtelierB.
; Historique :
; Historique : Revision 1.12  2000/10/18 14:36:03  clb
; Historique : ouverture d'un composant sur la liste des POs.
; Historique : clic sur une PO => ouverture du tampon Log.
; Historique :
; Historique : Revision 1.11  2000/10/12 16:10:01  clb
; Historique : Amelioration du temps de chargement : widget-setup quand il faut.
; Historique :
; Historique : Revision 1.10  2000/10/12 13:51:55  clb
; Historique : Suppression de la fenetre global situation :
; Historique : les infos se retrouvent dans la ligne de mode (modeline).
; Historique :
; Revision 1.9  2000/10/03  12:46:08  clb
; Ajout des tampons de liste des projets et des composants.
; Ils permettent a l'utilisateur de choisir plus facilement
; le projet et le composant voulu.
;
; Revision 1.8  2000/10/02  14:22:09  clb
; On affiche seulement les POs non-prouvees dans la liste des POs.
; L'utilisateur pourra choisir de voir les POs prouvees,
; quand le menu customize sera fait.
;
; Revision 1.7  2000/10/02  13:23:30  clb
; Suppression de la fenetre terminal.
; C'est le minibuffer qui sert de terminal.
; Revue des autoloads suite a la compilation de tous les fichiers.
; La seule fenetre au debut est la fenetre Log.
; Correction de pri-version qui etait defini deux fois differements.
; Ajout du fichier pri-traces.el
;
; Revision 1.6  2000/09/27  16:20:00  clb
; Ajout de la toolbar PRI : elle ne contient pour l'instant que le bouton Exit.
; pri-quit => pri-exit.
;
; Revision 1.5  2000/09/26  14:39:49  clb
; ajout d'un mode trace pour le debug.
; pri-trace ==> pri-terminal-print.
; enlevement du autoload de pri-trace aux endroits inutiles.
;
; Revision 1.4  2000/09/25  12:35:50  clb
; synchronisation d'Emacs et du prouvuer interactif :
; attente du prompt PRI> avant de lancer une nouvelle commande.
; enlevement des traces du debut d'Emacs dans la fenetre terminal :
; on arrive sur : PRI>.
;
; Revision 1.3  2000/09/22  14:49:25  clb
; Enlevement des blancs inutiles dans la fenetre Log.
;
; Historique : Revision 1.2  2000/06/30 09:37:46  clb
; Historique : ajout des entetes de fichiers
; Historique :
;
;*****************************************************************************
(autoload 'pri-trace "pri-traces")
(autoload 'pri-send-command "pri-terminal")
(autoload 'pri-interactive-send-command-p "pri-terminal")
(autoload 'pri-log-print-p "pri-log")
(autoload 'pri-output-buffer "pri-tools")
(autoload 'pri-end-of-buffer "pri-tools")
(autoload 'pri-operation-name "pri-main")
(autoload 'PRI-LOG "pri-main")
(autoload 'pri-before-writting-buffer "pri-main")
(autoload 'pri-after-writting-buffer "pri-main")
(require 'wid-edit)
(autoload 'widget-create "wid-edit")
(autoload 'push-button "wid-edit")
;;(autoload 'pri-toolbar "pri-toolbar")

;;*****************************************************************************
;; VARIABLES CUSTOMIZABLES
(defcustom pri-show-proved-pos nil
  "*Non-nil means show proved prooved obligations."
  :type 'boolean
  :group 'pri)

;;*****************************************************************************
;; VARIABLES 
;sauvegarde du widget de la PO selectionnee
(defvar pri-selected-widget nil)

;nb de POs unproved
(eval-and-compile
(defvar pri-current-po "0")
(defvar pri-current-po-state "")
(defvar pri-current-operation "")
(defvar pri-nb-unproved-pos 0)
(defvar pri-nb-unproved-pos-string "0")
(defvar pri-nb-pos 0)
(defvar pri-nb-pos-string "0"))

(defvar pri-beginning-p t)
;;*****************************************************************************
;; FUNCTIONS
(eval-and-compile
(defun pri-current-po (po-number)
  (setq pri-current-po po-number)
  (setq pri-current-operation pri-operation-name)))

(eval-and-compile
(defun pri-current-po-state (state)
  (setq pri-current-po-state state)))

(eval-and-compile
(defun pri-add-po (po-number state  operation)
  (pri-trace (format "--> pri-add-po:%s,%d\n" state pri-nb-pos))
  (set-buffer PRI-PO-LIST)
  (goto-char (point-max))
  (setq pri-nb-pos (+ pri-nb-pos 1))
  (if (string= state "unproved")
	  (setq pri-nb-unproved-pos (+ pri-nb-unproved-pos 1)))
  ;; on affiche la PO si elle est unproved ou si on a demande a avoir 
  ;; aussi les POs prouvees
  (if (or (string= state "unproved")
		  pri-show-proved-pos)
	  (progn  
		(widget-create
		 'push-button
		 :tag "PO"
		 :button-suffix (concat po-number " " state)
		 :notify (lambda (widget &rest ignore)
				   (setq pri-output-buffer PRI-PO-LIST)
				   (set-buffer PRI-PO-LIST)
				   (pri-send-command 
					(concat
					 "go ("
					 (widget-get widget :op)
					 "."
					 (widget-get widget :numero)
					 ")&wx&ws")
					)
				   (let* ((log-window (get-buffer-window PRI-LOG 'visible)))
					 (if (not log-window)
					   (progn
						 (setq pri-log-window (selected-window))
						 (set-window-buffer pri-log-window PRI-LOG)
						 (pri-log-print  "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n")
						 (setq pri-output-buffer PRI-LOG)
						 (goto-char (point-max)))
					   (progn
					   (select-window log-window)
					   (pri-end-of-buffer))))
					 
				   ;;(if (and pri-log-print-p pri-interactive-send-command-p pri-beginning-p)
					;;   (progn
					;;	 (setq  pri-interactive-send-command-p nil)
					;;	 (setq  pri-beginning-p nil)
					;;	 (call-interactively 'pri-send-command)))

				   (widget-put widget :selec nil)
				   ;;redraw the button
				   (widget-setup))
		 
		 :format "\t%[%t%]\n"
		 :selec nil
		 :numero po-number
		 :etat nil
		 :op operation
		 )))))

;;remet le nb de POS unproved a 0
(eval-and-compile
(defun pri-reset-po ()
  (setq pri-nb-unproved-pos 0)
  (setq pri-nb-pos 0)))

(eval-and-compile
(defun pri-modeline ()
  (setq pri-nb-unproved-pos-string (int-to-string pri-nb-unproved-pos))
  (setq pri-nb-pos-string (int-to-string pri-nb-pos))
  (setq mode-name (concat
				   pri-nb-unproved-pos-string
				   "Un/"
				   pri-nb-pos-string
				   "PO "
				   pri-current-po-state
				   " "
				   pri-component-name
				   "."
				   pri-current-operation
				   "."
				   pri-current-po
				   ))))

;;mode liste des po
(eval-and-compile 
(defun pri-po-list-mode ()
  "Mode de la liste des po"
  (pop-to-buffer PRI-PO-LIST)
  (kill-all-local-variables)
  (use-local-map pri-mode-map)
  (pri-create-menu)
 ;; (pri-toolbar)
 ;; (set-default-toolbar-position 'bottom)
  (setq major-mode 'pri-po-list-mode)
  (setq mode-popup-menu  
		`("Actions on Hypothesis" 
		  [ "ah - Add hypothesis" (pri-prouveur-send-command  "") t]
		 ;; [ "fh - False hypothesis"  (pri-process-hyp-command "fh") t] 
		  [ "eh - Use Equality in Hypothesis in Goal"  (pri-prouveur-send-command  "eh") t]
		 ;; [ "eh(AllHyp) - Use Equality in Hypothesis in All Hypothesis" (pri-process-hyp-command "eh" "AllHyp") t]
		 ;; [ "sh - Search Hypothesis" (pri-process-hyp-command "sh") t]
		  [ "mh - Modus Ponens" (pri-prouveur-send-command  "mh") t]
		  ))

;; (setq mode-popup-menu  
;; 		`("Actions on Hypothesis" 
;; 		  [ "ah - Add hypothesis" (pri-process-hyp-command "ah") t]
;; 		  [ "fh - False hypothesis"  (pri-process-hyp-command "fh") t] 
;; 		  [ "eh(Goal) - Use Equality in Hypothesis in Goal" (pri-process-hyp-command "eh" "Goal") t]
;; 		  [ "eh(AllHyp) - Use Equality in Hypothesis in All Hypothesis" (pri-process-hyp-command "eh" "AllHyp") t]
;; 		  [ "sh - Search Hypothesis" (pri-process-hyp-command "sh") t]
;; 		  [ "mh - Modus Ponens" (pri-process-hyp-command "mh") t]
;; 		  ))
))


;;*****************************************************************************
;;declaration des services
(provide 'pri-po-list-mode)
