;******************************* STERIA **************************************
; Fichier : $Id: pri-proof-tree.el,v 1.13 2000/10/31 14:49:01 clb Exp $
;
; (C) 2000 STERIA
;
; Description : Fenetre de l'arbre de preuve
;               
; Auteur(s) :  clb
;
; Historique : $Log: pri-proof-tree.el,v $
; Historique : Revision 1.13  2000/10/31 14:49:01  clb
; Historique : Ajout du sous-menu Proof Paste dans l'arbre de preuve.
; Historique :
; Revision 1.12  2000/10/30  17:24:28  clb
; Les parties ininteressantes de l'arbre de preuve sont cachees par defaut.
;
; Revision 1.11  2000/10/30  16:19:23  clb
; Correction de l'expression reguliere pour le mode outline
; dans l'arbre de preuve.
;
; Revision 1.10  2000/10/30  14:11:41  clb
; Ajout du mode outline pour l'arbre de preuve : pri-proof-tree.
; Permet de cahcher/etendre un bout dans l'arbre de preuve.
;
; Historique : Revision 1.9  2000/10/26 09:47:07  clb
; Historique : Les buffers : goal, hyp, proof-tree et old-proof sont maintenant read-only.
; Historique :
; Historique : Revision 1.8  2000/10/24 08:09:33  clb
; Historique : Modification des messages pour la version 3.6 de l'AtelierB.
; Historique :
; Historique : Revision 1.7  2000/10/12 13:51:55  clb
; Historique : Suppression de la fenetre global situation :
; Historique : les infos se retrouvent dans la ligne de mode (modeline).
; Historique :
; Revision 1.6  2000/10/02  13:23:31  clb
; Suppression de la fenetre terminal.
; C'est le minibuffer qui sert de terminal.
; Revue des autoloads suite a la compilation de tous les fichiers.
; La seule fenetre au debut est la fenetre Log.
; Correction de pri-version qui etait defini deux fois differements.
; Ajout du fichier pri-traces.el
;
; Revision 1.5  2000/09/27  16:20:00  clb
; Ajout de la toolbar PRI : elle ne contient pour l'instant que le bouton Exit.
; pri-quit => pri-exit.
;
; Revision 1.4  2000/09/26  14:39:50  clb
; ajout d'un mode trace pour le debug.
; pri-trace ==> pri-terminal-print.
; enlevement du autoload de pri-trace aux endroits inutiles.
;
; Revision 1.3  2000/09/25  12:35:50  clb
; synchronisation d'Emacs et du prouvuer interactif :
; attente du prompt PRI> avant de lancer une nouvelle commande.
; enlevement des traces du debut d'Emacs dans la fenetre terminal :
; on arrive sur : PRI>.
;
; Revision 1.2  2000/06/30  09:37:46  clb
; ajout des entetes de fichiers
;
;
;*****************************************************************************
(autoload 'pri-toolbar "pri-toolbar")
;;(autoload 'pri-atelierb-mode "pri-atelierb-mode")
(autoload 'pri-machines-mode "pri-machines-mode")
(autoload 'PRI-PROOF-TREE "pri-main")
(autoload 'pri-send-command "pri-terminal")


;;*****************************************************************************
;; lance un ensemble de commandes selectionnees a la souris

(eval-and-compile 
(defun cansell-pri-send-command-list (l)
(if (cdr l) 
 (progn
  ( pri-send-command (car l))
  (cansell-pri-send-command-list (cdr l))
)
 (progn  (setq cansell-mouse-in-pri-log t) (setq cansell-marque-dec-as t)( pri-send-command (car l)))
)))

(eval-and-compile 
(defun pri-proof-tree-paste ()
  "Mode de l'arbre de preuve"
  (if (region-active-p)
	  (let ((pri-buffer-string (buffer-string (mark) (point))))
	   ;; (set-window-buffer pri-log-window PRI-LOG)(set-buffer  PRI-LOG)
		(setq pri-buffer-string
			  (replace-in-string pri-buffer-string "[ \t][ \t]+" " "))
		(setq pri-buffer-string (replace-in-string pri-buffer-string "/\*.*	\*/\n" ""))	
	;;	(setq pri-buffer-string
	;;		  (replace-in-string pri-buffer-string "\n" "&"))

	
		
	;;	(if (string-match "^.*&$" pri-buffer-string)
	;;		(setq pri-buffer-string (substring pri-buffer-string 0
	;;										(- (length pri-buffer-string) 1))))
	;;	
	;;(pri-trace (concat "cmd : " pri-buffer-string))
       (let ((list-cmd (pri-split-string pri-buffer-string "\n")))
          
	
		(cansell-pri-send-command-list list-cmd))
		;;(cansell-affiche-dans-pri-errors pri-buffer-string)
)
	
	(message "you must select a part of the tree before"))))

(defvar B-mode-syntax-table nil
  "Syntax table in use in B-mode buffers. Should make word selection
and word move easy.")
(if B-mode-syntax-table
    ()
  (setq B-mode-syntax-table (make-syntax-table))

  ; symboles speciaux ou d'operateurs : categorie poubelle "."
  ; serait mieux si les agregats formaient des symboles :
  ;   ex : aaa/|\bbb devraient etre trois mots, et dble clic dans /|\ devrait
  ;        selectionner ce symbole. Actuellement : aaa et bbb sont les seuls mots.
  (modify-syntax-entry ?! "." B-mode-syntax-table)
  (modify-syntax-entry ?# "." B-mode-syntax-table)
  (modify-syntax-entry ?% "." B-mode-syntax-table)
  (modify-syntax-entry ?& "." B-mode-syntax-table)
  (modify-syntax-entry ?+ "." B-mode-syntax-table)
  (modify-syntax-entry ?, "." B-mode-syntax-table)
  (modify-syntax-entry ?- "." B-mode-syntax-table)
  (modify-syntax-entry ?. "." B-mode-syntax-table)
  (modify-syntax-entry ?: "." B-mode-syntax-table)
  (modify-syntax-entry ?\; "." B-mode-syntax-table)
  (modify-syntax-entry ?< "." B-mode-syntax-table)
  (modify-syntax-entry ?= "." B-mode-syntax-table)
  (modify-syntax-entry ?> "." B-mode-syntax-table)
  (modify-syntax-entry ?? "." B-mode-syntax-table)
  (modify-syntax-entry ?\\ "." B-mode-syntax-table)
  (modify-syntax-entry ?^ "." B-mode-syntax-table)
  (modify-syntax-entry ?| "." B-mode-syntax-table)
  (modify-syntax-entry ?` "." B-mode-syntax-table)

  ; les quoted strings sont delimitees par des doubles quotes
  (modify-syntax-entry ?\" "\"" B-mode-syntax-table)

  ; les caracteres ne devant pas couper un mot
  ; ex : dble clic sur toto_titi, var$3, zzz~ ou fff'ddd doit selectionner
  ;      ces elements en entier.
  ; ATTENTION : les categories "_" ou "'" n'ont pas ete employees : sur Emacs
  ;   elles n'ont pas la propriete ci dessus. Pourtant, le concept de "symbole"
  ;   dans la doc de ces categories semblerait convenir... A voir.
  (modify-syntax-entry ?$ "w" B-mode-syntax-table)
  (modify-syntax-entry ?\' "w" B-mode-syntax-table)
  (modify-syntax-entry ?_ "w" B-mode-syntax-table)
  (modify-syntax-entry ?~ "w" B-mode-syntax-table)

  ; commentaires. On ne supporte pas le // C++
  ; pris isolement : categorie "." pour / et *
  ; / est le 1 du commentaire ouvrant et le 2 du fermant (4)
  ; * est le 2 du commentaire ouvrant et le 1 du fermant (3)
  (modify-syntax-entry ?* ". 23" B-mode-syntax-table)
  (modify-syntax-entry ?/ ". 14" B-mode-syntax-table)

  ; les parentheses : (X)emacs signale la correspondance a chaque fermante,
  ;   et dble clic sur une parenthese selectionne le bloc delimite.
  ; () sont predefinis.
  (modify-syntax-entry ?\[ "(]" B-mode-syntax-table)
  (modify-syntax-entry ?\] ")]" B-mode-syntax-table)
  (modify-syntax-entry ?\{ "(}" B-mode-syntax-table)
  (modify-syntax-entry ?\} ")}" B-mode-syntax-table))

(defconst pri-proof-tree-font-lock-keywords
  (purecopy
   (list
        '("^\\(MACHINE\\|SETS\\|CONSTANTS\\|PROPERTIES\\|ASSERTIONS\\|REFINEMENT\\|REFINES\\|VARIABLES\\|INVARIANT\\|INITIALISATION\\|OPERATIONS\\|END\\)". pri-proof-tree-red-bold-face) 
        '("\\(SELECT\\|IF\\|THEN\\|ANY\\|WHERE\\|ELSE\\|BEGIN\\|END\\)". pri-proof-tree-blue-bold-face) 
;;	'("^   goal:.*$" . pri-proof-tree-inverse-face)
 '(".*&$" . pri-proof-tree-test-bold-face)
 '(" .*" . pri-proof-tree-test-bold-face)


	;; resultats des commandes
;;	(list "^cmd:.*\n\\(.*\\)$" '(1 pri-proof-tree-inverse-face t))
;;	'("^cmd:" . pri-proof-tree-inverse-face)
	'("\\*\\*\\|\\+->>?\\|-\\(?:->>?\\|>\\)\\|\\.\\.\\|/\\(?:<\\(?::\\|<:\\)\\||\\\\\\|[:=\\]\\)\\|:[:=]\\|<\\(?:-[>-]\\|<[:|]\\|=>\\|[+:=|-]\\)\\|=>\\|>\\(?:\\+>>?\\|->>?\\|[<=]\\)\\|\\\\\\(?:/\\||/\\)\\||\\(?:->\\|>>\\|[>|]\\)\\|[!#%&'*+,./:->|~^-]" . font-lock-function-name-face)
	'("\\<\\(INTER\\|PI\\|SIGMA\\|UNION\\|bool\\|c\\(?:ard\\|losure1?\\|onc\\)\\|dom\\|f\\(?:irst\\|nc\\|ront\\)\\|i\\(?:d\\|nter\\|terate\\)\\|last\\|m\\(?:ax\\|in\\|od\\)\\|not\\|or\\|pr\\(?:ed\\|j[12]\\)\\|r\\(?:an\\|e[clv]\\)\\|s\\(?:ize\\|ucc\\)\\|tail\\|union\\)\\>" . font-lock-function-name-face)
	'("\\<\\(BOOL\\|F\\(?:ALSE\\|IN1?\\)\\|INT\\(?:EGER\\)?\\|M\\(?:AXINT\\|ININT\\)\\|NAT\\(?:1\\|URAL1?\\)?\\|POW1?\\|STRING\\|TRUE\\|\\[\\]\\|iseq1?\\|perm\\|s\\(?:eq1?\\|kip\\|truct\\)\\|{}\\)\\>" . font-lock-type-face)
       
	))
  "Highlight B")

;;*****************************************************************************
;;mode arbre de preuve
(eval-and-compile 
(defun pri-proof-tree-mode ()
  "Mode de l'arbre de preuve"
  (pop-to-buffer PRI-PROOF-TREE)
  (pri-atelierb-mode)
  (x-symbol-mode)
  (interactive)
;;(scroll-up (max 0 (- (length cansell-pour-aff-proof-tree) 13)))
  (kill-all-local-variables)
  (make-face 'pri-proof-tree-red-bold-face)
  (make-face 'pri-proof-tree-test-bold-face)
  (make-face 'pri-proof-tree-red-face)
 (make-face 'pri-proof-tree-blue-face) 
 (make-face 'pri-proof-tree-blue-bold-face)
  (make-face 'pri-proof-tree-button-red-face)
  (make-face 'pri-proof-tree-button-blue-face)
  (custom-set-faces
   '(pri-proof-tree-red-bold-face ((((class color))  (:foreground "red"))))
   '(pri-proof-tree-red-face ((((class color))  (:foreground "red"))))
   '(pri-proof-tree-blue-face ((((class color))  (:foreground "blue")))) 
   '(pri-proof-tree-blue-bold-face ((((class color))  (:foreground "blue")))) 
   '(pri-proof-tree-test-bold-face ((((class color))  (:foreground "black"))));; '(pri-proof-tree-button-red-face ((t  (:bold t) (:foreground "red"))))
)
  (make-face-bold 'pri-proof-tree-red-bold-face)
  (make-face-bold 'pri-proof-tree-blue-bold-face)
  (make-face-bold 'pri-proof-tree-test-bold-face)
 (copy-face 'widget-button-face 'pri-proof-tree-button-red-face)
(set-face-foreground 'pri-proof-tree-button-red-face"red")
 (copy-face 'widget-button-face 'pri-proof-tree-button-blue-face)
(set-face-foreground 'pri-proof-tree-button-blue-face"blue")

;;   '(pri-proof-tree-inverse-face ((((class color)) (:foreground "white" :background "black")))))
  (setq major-mode 'pri-proof-tree-mode)
  (setq mode-name "PRI")

  (run-hooks 'pri-proof-tree-mode-hook)
  (turn-on-font-lock)

  (set-syntax-table B-mode-syntax-table)


 ;; (pri-toolbar)
 (setq truncate-lines t) 
  (setq buffer-read-only nil)
 (setq inhibit-read-only t) 
  ;;(pri-toolbar)
  (setq mode-popup-menu  
		`("Actions on Proof Tree" 
		  ["ba - Back" (pri-send-command "ba") t]
		  [ "st - Step"  (pri-send-command "st") t] 
		  [ "st(End) - Step to End" (pri-send-command "st(End)") t]
		  [ "re - Reset" (pri-send-command "re") t]
		  [ "Proof Paste" (pri-proof-tree-paste) t]
		  ))
  ;;(setq buffer-read-only t)
 ;; (outline-minor-mode)
  ;;(setq outline-regexp  "\\(  \\|^L\\)+")
))

;;*****************************************************************************
;;declaration des services
(provide 'pri-proof-tree-mode)
